(*============================================================================*)
(* ABOUT.PAS -- About BPGN viewer window                                      *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2002-2005 Fermy                          *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.03: First construction.                                            *)
(* 1998.11.07: Changed version from 0.92 alpha to 0.93 alpha.                 *)
(* 1998.11.09: Changed (c) 1988 to (c) 1998.                                  *)
(* 1998.11.11: Changed the maximum # of comment characters from 0 to 64,000.  *)
(* 1998.11.12: Changed version to 0.95.                                       *)
(* 1998.11.14: Changed version to 0.96.                                       *)
(* 1998.11.16: Changed version 1.00 beta.                                     *)
(* 1998.11.17: Changed version 1.01 beta.                                     *)
(* 1998.11.18: Changed version 1.02 beta.                                     *)
(* 1998.11.19: 1) Changed version to 1.03 beta.                               *)
(*             2) Added Bughouse web page.                                    *)
(* 1998.11.21: Changed version to 1.04 beta.                                  *)
(* 1998.11.22: 1) Removed () off bughouse web page.                           *)
(*             2) Added notes on where to get free chess fonts.               *)
(*             3) Changed version to 1.05 beta.                               *)
(*             4) Changed version to 1.06 beta.                               *)
(* 1998.11.23: Changed version to 1.07 beta.                                  *)
(* 1998.11.24: 1) Changed version to 1.08 beta.                               *)
(*             2) Changed version to 1.09 beta.                               *)
(* 1998.11.25: Changed version to 1.10 beta.                                  *)
(* 1998.11.27: Changed version to 1.11 beta.                                  *)
(* 1998.12.16: 1) Added FICS logo.                                            *)
(*             2) Changed version to 1.12 beta.                               *)
(* 1999.01.20: 1) Added code to read in Crazyhouse games (determined by event *)
(*               tag in BPGN file: [Event "fics unrated crazyhouse match"]).  *)
(*               If it's a crazyhouse game then the captured piece's color    *)
(*               will be reversed and into player's piece buffer instead of   *)
(*               going to player partner's piece buffer as in regular         *)
(*               bughouse games.                                              *)
(*            2) Changed version ID to 1.13 beta.                             *)
(* 2002.01.25: Changed text to update credits/webpage info.                   *)
(* 2004.11.07: Updated special thanks                                         *)
(* 2004.12.23: Update links, replaced labels with clickable ones              *)
// 2004.12.30: Updated links, thanks.
// 2005.02.15: Updated URL of Skacz's page
(*============================================================================*)
UNIT ABOUT;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    ComCtrls, StdCtrls, ExtCtrls,
    GLOBAL,INI1, SRLabel;


TYPE
    TAboutForm = CLASS(TForm)
        PageControl1: TPageControl;
        TabSheet1:    TTabSheet;
        TabSheet2:    TTabSheet;
        TabSheet3:    TTabSheet;
        TabSheet4:    TTabSheet;
        TabSheet5:    TTabSheet;
        TabSheet6:    TTabSheet;

        Label1:       TLabel;
        Label2:       TLabel;
        Label3:       TLabel;
        Label5:       TLabel;
        Label6:       TLabel;
        Label7:       TLabel;
        Label8:       TLabel;
        Label9:       TLabel;
        Label10:      TLabel;
        Label11:      TLabel;
        Label12:      TLabel;
        Label13:      TLabel;
        Label14:      TLabel;
        Label15:      TLabel;
        Label16:      TLabel;
        Label17:      TLabel;
        Label18:      TLabel;
        Label19:      TLabel;
    Label21: TSRLabel;
        Label22:      TLabel;
    Label23: TSRLabel;
        Label25:      TLabel;
        Label26:      TLabel;
        Label27:      TLabel;

        Image1:       TImage;

        Button1:      TButton;
    Label28: TLabel;
    Label29: TLabel;
    Label24: TSRLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    SRLabel1: TSRLabel;
    Label20: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TSRLabel;
    Label40: TLabel;
    Label41: TSRLabel;
    Label42: TLabel;
    Label43: TSRLabel;
    Label44: TLabel;
    SRLabel2: TSRLabel;
    Label45: TLabel;
    SRLabel3: TSRLabel;
    SRLabel4: TSRLabel;
    SRLabel5: TSRLabel;
    SRLabel6: TSRLabel;
    SRLabel7: TSRLabel;
    Label4: TLabel;
    Label46: TLabel;
    Label47: TLabel;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE SetupValues;
        PROCEDURE Button1Click(Sender: TObject);

        PRIVATE
        { Private declarations }

        PUBLIC
        { Public declarations }
    END;


IMPLEMENTATION

{$R *.DFM}

PROCEDURE TAboutForm.FormCreate(Sender: TObject);
BEGIN
    Left := (Screen.Width  - Width ) SHR 1;
    Top  := (Screen.Height - Height) SHR 1;

    {Image1.Picture.Bitmap.Handle := LoadBitmap(HInstance, 'LOGO');}
END;

PROCEDURE TAboutForm.SetupValues;
VAR
    nSize: LongInt;
BEGIN
    PageControl1.ActivePage := TabSheet1;
    ActiveControl           := TabSheet1;

    Label8.Caption  := '1. ' + IntToStr(MAX_Position) + ' positions per BPGN game.';
    Label9.Caption  := '2. 1 main line and ' + IntToStr(MAX_NEXT - 1) + ' variations per position.';
    Label10.Caption := '3. 3 characters per annotation symbol.';
    Label11.Caption := '4. ' + IntToStr(MAX_MEMO_CHAR) + ' characters per comment.';
END;

PROCEDURE TAboutForm.Button1Click(Sender: TObject);
BEGIN
    Close;
END;

END.
