(*============================================================================*)
(* ANNOTATE.PAS -- Annotate current move window                               *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.03: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)
UNIT ANNOTATE;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, Buttons,global;


TYPE
    TAnnotateForm = CLASS(TForm)
        Label1: TLabel;
        Label2: TLabel;
        Label3: TLabel;

        Edit1:  TEdit;

        Button1: TButton;
        Button2: TButton;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE SetupValues;
        PROCEDURE Button1Click(Sender: TObject);
        PROCEDURE Button2Click(Sender: TObject);
        PROCEDURE Edit1Exit(Sender: TObject);

        PRIVATE
        { Private declarations }
        PUBLIC
        { Public declarations }
        bOK:      Boolean;
        cMove:    String;
        cAnno:    String;
    END;


IMPLEMENTATION

{$R *.DFM}

PROCEDURE TAnnotateForm.FormCreate(Sender: TObject);
BEGIN
    Left  := (Screen.Width  - Width ) SHR 1;
    Top   := (Screen.Height - Height) SHR 1;
    cMove := '';
    cAnno := '';
END;

PROCEDURE TAnnotateForm.SetupValues;
BEGIN
    bOK            := FALSE;
    ActiveControl  := Edit1;
    Label2.Caption := cMove;
    Edit1.Text     := Trim(cAnno);
END;

PROCEDURE TAnnotateForm.Edit1Exit(Sender: TObject);
BEGIN
    Edit1.Text := Trim(Edit1.Text);
    IF (Length(Edit1.Text) > 3) THEN
        Edit1.Text := Copy(Edit1.Text,1,3);
END;

PROCEDURE TAnnotateForm.Button1Click(Sender: TObject);
BEGIN
    bOK := TRUE;
    IF (Length(Edit1.Text) > 3) THEN
        cAnno := Trim(Copy(Edit1.Text,1,3))
    ELSE
        cAnno := Edit1.Text;
    Close;
END;

PROCEDURE TAnnotateForm.Button2Click(Sender: TObject);
BEGIN
    bOK := FALSE;
    Close;
END;

END.
