(*============================================================================*)
(* CLOCK.PAS -- Edit clock window                                             *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.03: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)
UNIT CLOCK;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, Buttons,
    MISC, TOOLBOX,global;


TYPE
    TClockForm = CLASS(TForm)
        Label1: TLabel;
        Label2: TLabel;
        Label4: TLabel;
        Label5: TLabel;

        CheckBox1: TCheckBox;
        Edit2:  TEdit;
        Edit3:  TEdit;

        Button1: TButton;
        Button2: TButton;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE SetupValues;
        PROCEDURE Button1Click(Sender: TObject);
        PROCEDURE Button2Click(Sender: TObject);
        PROCEDURE Edit2Exit(Sender: TObject);
        PROCEDURE Edit3Exit(Sender: TObject);

        PRIVATE
        { Private declarations }
        PUBLIC
        { Public declarations }
        bOK:       Boolean;
        cOrgClock: String;
        cNewClock: String;
        nNewClock: Integer;
    END;


IMPLEMENTATION

{$R *.DFM}

PROCEDURE TClockForm.FormCreate(Sender: TObject);
BEGIN
    Left      := (Screen.Width  - Width ) SHR 1;
    Top       := (Screen.Height - Height) SHR 1;
    cOrgClock := '';
    cNewClock := '';
    nNewClock := -1;
END;

PROCEDURE TClockForm.SetupValues;
VAR
    bN: Boolean;
    nS: Integer;
    cM, cS: String;
BEGIN
    bOK            := FALSE;
    ActiveControl  := CheckBox1;
    Label2.Caption := cOrgClock;

    nS := Length(cOrgClock);
    IF (nS = 0) THEN
    BEGIN
        cOrgClock := '00:00';
        nS        := Length(cOrgClock);
    END;

    IF (cOrgClock[1] = '-') THEN
    BEGIN
        bN := TRUE;
        cM := Copy(cOrgClock,2,2);
        cS := Copy(cOrgClock,5,length(cOrgClock));
    END
    ELSE
    IF (cOrgClock[1] = '+') THEN
    BEGIN
        bN := FALSE;
        cM := Copy(cOrgClock,2,2);
        cS := Copy(cOrgClock,5,length(cOrgClock));
    END
    ELSE
    BEGIN
        bN := FALSE;
        cM := Copy(cOrgClock,1,2);
        cS := Copy(cOrgClock,4,length(cOrgClock));
    END;

    CheckBox1.Checked := bN;
    Edit2.Text        := cM;
    Edit3.Text        := cS;
END;

PROCEDURE TClockForm.Edit2Exit(Sender: TObject);
BEGIN
    Edit2.Text := Trim(Edit2.Text);
    IF (Length(Edit2.Text) = 0) THEN
        Edit2.Text := '00';
    IF (Length(Edit2.Text) > 2) THEN
        Edit2.Text := Copy(Edit2.Text,1,2);
END;

PROCEDURE TClockForm.Edit3Exit(Sender: TObject);
BEGIN
    Edit3.Text := Trim(Edit3.Text);
    IF (Length(Edit3.Text) = 0) THEN
        Edit3.Text := '00';
//    IF (Length(Edit3.Text) > 2) THEN
//        Edit3.Text := Copy(Edit3.Text,1,2);
END;

PROCEDURE TClockForm.Button1Click(Sender: TObject);
VAR
    bE: Boolean;
    cTmp: String;
    nI, nMinute, nTmp: Integer;
    nSecond:real;
BEGIN
    IF (Length(Edit2.Text) = 0) THEN
        nMinute := 0
    ELSE
    BEGIN
        bE := FALSE;
        FOR nI := 1 TO Length(Edit2.Text) DO
        BEGIN
            IF ((Edit2.Text[nI] < '0') OR (Edit2.Text[nI] > '9')) THEN
            BEGIN
                bE := TRUE;
                BREAK;
            END;
        END;
        IF (bE) THEN
        BEGIN
            wError('Invalid minute.');
            ActiveControl := Edit2;
            EXIT;
        END;
        VAL(Edit2.Text, nMinute, nTmp);
        IF (nTmp <> 0) THEN
        BEGIN
            wError('Invalid minute.');
            ActiveControl := Edit2;
            EXIT;
        END;
        IF (nMinute > 59) THEN
        BEGIN
            wError('Invalid minute.');
            ActiveControl := Edit2;
            EXIT;
        END;
    END;

    IF (Length(Edit3.Text) = 0) THEN
        nSecond := 0
    ELSE
    BEGIN
        VAL(Edit3.Text, nSecond, nTmp);
        IF (nTmp <> 0) THEN
        BEGIN
            wError('Invalid second.');
            ActiveControl := Edit3;
            EXIT;
        END;
        IF ((nSecond >= 60) or (nSecond<0)) THEN
        BEGIN
            wError('Invalid second.');
            ActiveControl := Edit3;
            EXIT;
        END;
    END;

    bOK := TRUE;

    nNewClock := Round(1000*((nMinute * 60) + nSecond));

    IF (CheckBox1.Checked) THEN
        nNewClock := 0 - nNewClock;

    cNewClocK:=TOOLBOX_GetDispTimeStr(nNewClock);

    Close;
END;

PROCEDURE TClockForm.Button2Click(Sender: TObject);
BEGIN
    bOK := FALSE;
    Close;
END;

END.
