(*============================================================================*)
(* COMMENT.PAS -- Comment window                                              *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.03: First construction.                                            *)
(* 1998.11.13: Removed the horizontal scroll bar since memo's wordwrap is on. *)
(* 1998.11.14: Added horitontal scroll bar and turned off wordwrap.           *)
(* 1998.11.27: Added word wrap into comment/option.                           *)
(*                                                                            *)
(*============================================================================*)
UNIT COMMENT;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls,
    GLOBAL, TOOLBOX,INI1,misc;


TYPE
    TCommentForm = CLASS(TForm)
        Memo1: TMemo;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE ResetAll;

        PRIVATE
        { Private declarations }
        PUBLIC
        { Public declarations }
    END;

VAR
    CommentForm: TCommentForm;

IMPLEMENTATION

{$R *.DFM}

PROCEDURE TCommentForm.FormCreate(Sender: TObject);
BEGIN
//    Werror('Creating comment form');
    Memo1.Color       := INI1.INI.nCommentB;
    Memo1.Font.Color  := INI1.INI.fCommentF.Color;
    Memo1.Font.Height := INI1.INI.fCommentF.Height;
    Memo1.Font.Name   := INI1.INI.fCommentF.Name;
    Memo1.Font.Pitch  := INI1.INI.fCommentF.Pitch;
    Memo1.Font.Size   := INI1.INI.fCommentF.Size;
    Memo1.Font.Style  := INI1.INI.fCommentF.Style;
    Memo1.MaxLength   := MAX_MEMO_CHAR;
    Memo1.WordWrap    := INI1.INI.bCommentWR;

    IF (Memo1.WordWrap) THEN
        Memo1.ScrollBars := ssVertical
    ELSE
        Memo1.ScrollBars := ssBoth;

    ResetAll;

    IF (INI1.INI.nCommentS <> 2) THEN
    BEGIN
        SetBounds(INI1.INI.nCommentL, INI1.INI.nCommentT,
                  INI1.INI.nCommentW, INI1.INI.nCommentH);
    END;
    WindowState := TOOLBOX_IntToWinState(INI1.INI.nCommentS);
    Caption     :='Comment';
END;

PROCEDURE TCommentForm.ResetAll;
BEGIN
    Memo1.Enabled := FALSE;
    Memo1.Clear;
END;

END.
