unit EngComLine;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,misc, ExtCtrls,
  Global;

type
  TComLineForm = class(TForm)
    OpenDialog1: TOpenDialog;
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    CheckBox1: TCheckBox;
    Edit3: TEdit;
    Label3: TLabel;
    Edit4: TEdit;
    Label4: TLabel;
    Edit5: TEdit;
    RadioGroup1: TRadioGroup;
    Label5: TLabel;
    CheckBox2: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);

  private
   procedure disableed;
   procedure enableed;
    { Private declarations }

  public
   bOk:boolean;
   Options:TEngineopt;

   procedure setupValues(opt:Tengineopt);
   procedure SaveValues;
   procedure refreshvalues;
    { Public declarations }
  end;


implementation
{$R *.DFM}

procedure setupsjeng(var opt:Tengineopt);
begin
 opt.prompt:='Sjeng:';
 opt.reset:='new';
 opt.itime:='st 1800000';
 opt.banal:=true;
end;

procedure setupsun(var opt:Tengineopt);
begin
 opt.prompt:='';
 opt.reset:='reset';
 opt.itime:='sd 24';
 opt.banal:=true;
end;

procedure tcomlineform.disableed;
begin
  edit3.enabled:=false;
  edit4.enabled:=false;
  edit5.enabled:=false;
  checkbox2.enabled:=false;
end;

procedure tcomlineform.enableed;
begin
  edit3.enabled:=true;
  edit4.enabled:=true;
  edit5.enabled:=true;
  checkbox2.enabled:=true;
end;

procedure TcomlineForm.refreshvalues;
begin
  checkbox2.checked:=options.banal;
  edit3.text:=options.prompt;
  edit4.text:=options.itime;
  edit5.text:=options.reset;
  if options.etype<>2 then disableed ;
end;

procedure  TcomLineForm.SetupValues(opt:Tengineopt);
begin
 options:=opt;
 Radiogroup1.itemindex:=options.etype;
 openDialog1.initialdir:=ExtractFilePath(options.comline);
  edit1.text:=options.comline;
  edit2.text:=options.name;
  CheckBox1.checked:=options.bfilter;
 bOk:=false;
 Checkbox2.checked:=options.banal;
end;

Procedure TComLineForm.SaveValues;
begin
 Options.name:=trim(edit2.text);
 Options.comline:=trim(edit1.text);
 Options.etype:=RadioGroup1.ItemIndex;
 Options.prompt:=trim(edit3.text);
 options.itime:=trim(edit4.text);
 options.reset:=trim(edit5.text);
 Options.bfilter:=Checkbox1.Checked;
 options.banal:=checkbox2.checked;
end;

procedure TComLineForm.Button1Click(Sender: TObject);
begin
 if OpenDialog1.execute then Edit1.text:=OpenDialog1.Filename;
end;

procedure TComLineForm.Button3Click(Sender: TObject);
begin
 bOk:=false;
 close;
end;

procedure TComLineForm.Button2Click(Sender: TObject);
var s:string;
begin
 s:=trim(edit1.text);
 if length(s)<1 then
 begin
  wError('Missing Command line');
  ActiveControl:=edit1;
  exit;
 end;
 s:=trim(edit2.text);
 if length(s)<1 then
 begin
  wError('Missing Engine Name');
  ActiveControl:=edit2;
  exit;
 end;
 bOk:=true;
 SaveValues;
 close;
end;

procedure TComLineForm.RadioGroup1Click(Sender: TObject);
begin
 options.etype:=RadioGroup1.ItemIndex;
 if options.etype=0 then setupsjeng(options);
 if options.etype=1 then setupsun(options);
 if options.etype=2 then enableed else disableed;
 refreshvalues;
end;

end.
