(*============================================================================*)
(* ENTERDT.PAS -- Edit date window                                            *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.06: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)
UNIT EnterDt;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls,
    MISC,global;


TYPE
    TDateForm = CLASS(TForm)
        Label1: TLabel;
        Label2: TLabel;
        Label3: TLabel;

        Edit1: TEdit;

        Button1: TButton;
        Button2: TButton;
        Button3: TButton;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE SetupValues;
        PROCEDURE Edit1Exit(Sender: TObject);
        PROCEDURE Button1Click(Sender: TObject);
        PROCEDURE Button2Click(Sender: TObject);
        PROCEDURE Button3Click(Sender: TObject);

        PRIVATE
        { Private declarations }
        PUBLIC
        { Public declarations }
        bOK:      Boolean;
        cOrgDate: String;
        cNewDate: String;
    END;


IMPLEMENTATION

{$R *.DFM}

PROCEDURE TDateForm.FormCreate(Sender: TObject);
BEGIN
    Left      := (Screen.Width  - Width ) SHR 1;
    Top       := (Screen.Height - Height) SHR 1;
    cOrgDate := '';
    cNewDate := '';
END;

PROCEDURE TDateForm.SetupValues;
BEGIN
    bOK            := FALSE;
    ActiveControl  := Edit1;
    Label2.Caption := cOrgDate;
    Edit1.Text     := cNewDate;
END;

PROCEDURE TDateForm.Edit1Exit(Sender: TObject);
BEGIN
    Edit1.Text := Trim(Edit1.Text);
END;

PROCEDURE TDateForm.Button1Click(Sender: TObject);
BEGIN
    IF (Length(Edit1.Text) = 0) THEN
    BEGIN
        wError('Missing date.');
        ActiveControl := Edit1;
        EXIT;
    END;

    bOK      := TRUE;
    cNewDate := Edit1.Text;

    Close;
END;

PROCEDURE TDateForm.Button2Click(Sender: TObject);
BEGIN
    bOK := FALSE;
    Close;
END;

PROCEDURE TDateForm.Button3Click(Sender: TObject);
BEGIN
    Edit1.Text := FormatDateTime('yyyy.mm.dd', Date);
END;

END.
