(*============================================================================*)
(* ENTERRC.PAS -- Edit result window                                          *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.06: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)
UNIT EnterRC;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls,
    MISC, TOOLBOX,global;


TYPE
    TResultForm = CLASS(TForm)
        Label1: TLabel;
        Label2: TLabel;
        Label3: TLabel;
        Label4: TLabel;

        Edit1: TEdit;

        RadioButton1: TRadioButton;
        RadioButton2: TRadioButton;
        RadioButton3: TRadioButton;
        RadioButton4: TRadioButton;

        Button1: TButton;
        Button2: TButton;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE SetupValues;
        PROCEDURE Edit1Exit(Sender: TObject);
        PROCEDURE RadioButton1Click(Sender: TObject);
        PROCEDURE RadioButton2Click(Sender: TObject);
        PROCEDURE RadioButton3Click(Sender: TObject);
        PROCEDURE RadioButton4Click(Sender: TObject);
        PROCEDURE Button1Click(Sender: TObject);
        PROCEDURE Button2Click(Sender: TObject);

        PRIVATE
        { Private declarations }
        PUBLIC
        { Public declarations }
        bOK:    Boolean;
        cOrgRC: String;
        cNewR1: String;
        cNewR2: String;
    END;


IMPLEMENTATION

{$R *.DFM}

PROCEDURE TResultForm.FormCreate(Sender: TObject);
BEGIN
    Left   := (Screen.Width  - Width ) SHR 1;
    Top    := (Screen.Height - Height) SHR 1;
    cOrgRC := '';
    cNewR1 := '';
    cNewR2 := '';
END;

PROCEDURE TResultForm.SetupValues;
BEGIN
    bOK            := FALSE;
    ActiveControl  := Edit1;
    Label2.Caption := cOrgRC;
    Edit1.Text     := cNewR1;

    RadioButton1.Checked := FALSE;
    RadioButton2.Checked := FALSE;
    RadioButton3.Checked := FALSE;
    RadioButton4.Checked := FALSE;

    IF (CompareText(cNewR2, BPGN_WHITE_WINS) = 0) THEN
        RadioButton1.Checked := TRUE
    ELSE
    IF (CompareText(cNewR2, BPGN_BLACK_WINS) = 0) THEN
        RadioButton2.Checked := TRUE
    ELSE
    IF (CompareText(cNewR2, BPGN_DRAW) = 0) THEN
        RadioButton3.Checked := TRUE
    ELSE
        RadioButton4.Checked := TRUE;
END;

PROCEDURE TResultForm.Edit1Exit(Sender: TObject);
VAR
    nL: Integer;
BEGIN
    Edit1.Text := Trim(Edit1.Text);
    nL         := Length(Edit1.Text);
    IF (nL > 0) THEN
    BEGIN
        IF (Edit1.Text[1] <> '{') THEN
        BEGIN
            Edit1.Text := '{' + Edit1.Text;
            nL         := Length(Edit1.Text);
        END;
        IF (Edit1.Text[nL] <> '}') THEN
            Edit1.Text := Edit1.Text + '}';
    END;
END;

PROCEDURE TResultForm.RadioButton1Click(Sender: TObject);
BEGIN
    RadioButton1.Checked := TRUE;
    RadioButton2.Checked := FALSE;
    RadioButton3.Checked := FALSE;
    RadioButton4.Checked := FALSE;
END;

PROCEDURE TResultForm.RadioButton2Click(Sender: TObject);
BEGIN
    RadioButton1.Checked := FALSE;
    RadioButton2.Checked := TRUE;
    RadioButton3.Checked := FALSE;
    RadioButton4.Checked := FALSE;
END;

PROCEDURE TResultForm.RadioButton3Click(Sender: TObject);
BEGIN
    RadioButton1.Checked := FALSE;
    RadioButton2.Checked := FALSE;
    RadioButton3.Checked := TRUE;
    RadioButton4.Checked := FALSE;
END;

PROCEDURE TResultForm.RadioButton4Click(Sender: TObject);
BEGIN
    RadioButton1.Checked := FALSE;
    RadioButton2.Checked := FALSE;
    RadioButton3.Checked := FALSE;
    RadioButton4.Checked := TRUE;
END;

PROCEDURE TResultForm.Button1Click(Sender: TObject);
BEGIN
    IF (Length(Edit1.Text) = 0) THEN
    BEGIN
        wError('Missing reason.');
        ActiveControl := Edit1;
        EXIT;
    END;

    bOK    := TRUE;
    cNewR1 := Edit1.Text;

    IF (RadioButton1.Checked) THEN
        cNewR2 := BPGN_WHITE_WINS
    ELSE
    IF (RadioButton2.Checked) THEN
        cNewR2 := BPGN_BLACK_WINS
    ELSE
    IF (RadioButton3.Checked) THEN
        cNewR2 := BPGN_DRAW
    ELSE
        cNewR2 := BPGN_UNKNOWN;

    Close;
END;

PROCEDURE TResultForm.Button2Click(Sender: TObject);
BEGIN
    bOK := FALSE;
    Close;
END;

END.
