(*============================================================================*)
(* ENTERTC.PAS -- Edit time control window                                    *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.06: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)
UNIT EnterTC;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls,
    MISC, TOOLBOX,global;


TYPE
    TTimeForm = CLASS(TForm)
        Label1: TLabel;
        Label2: TLabel;
        Label3: TLabel;
        Label4: TLabel;

        Edit1: TEdit;
        Edit2: TEdit;

        Button1: TButton;
        Button2: TButton;
        Button3: TButton;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE SetupValues;
        PROCEDURE Edit1Exit(Sender: TObject);
        PROCEDURE Edit2Exit(Sender: TObject);
        PROCEDURE Button1Click(Sender: TObject);
        PROCEDURE Button2Click(Sender: TObject);
        PROCEDURE Button3Click(Sender: TObject);

        PRIVATE
        { Private declarations }
        PUBLIC
        { Public declarations }
        bOK:       Boolean;
        cOrgTimeC: String;
        cNewTimeC: String;
    END;


IMPLEMENTATION

{$R *.DFM}

PROCEDURE TTimeForm.FormCreate(Sender: TObject);
BEGIN
    Left      := (Screen.Width  - Width ) SHR 1;
    Top       := (Screen.Height - Height) SHR 1;
    cOrgTimeC := '';
    cNewTimeC := '';
END;

PROCEDURE TTimeForm.SetupValues;
BEGIN
    bOK            := FALSE;
    ActiveControl  := Edit1;
    Label2.Caption := cOrgTimeC;
    Edit1.Text     := IntToStr(TOOLBOX_GetTimeVal(cOrgTimeC));
    Edit2.Text     := IntToStr(TOOLBOX_GetTimeIncVal(cOrgTimeC));
END;

PROCEDURE TTimeForm.Edit1Exit(Sender: TObject);
BEGIN
    Edit1.Text := Trim(Edit1.Text);
    IF (Length(Edit1.Text) > 3) THEN
        Edit1.Text := Copy(Edit1.Text,1,3);
END;

PROCEDURE TTimeForm.Edit2Exit(Sender: TObject);
BEGIN
    Edit2.Text := Trim(Edit2.Text);
    IF (Length(Edit2.Text) > 2) THEN
        Edit2.Text := Copy(Edit2.Text,1,2);
END;

PROCEDURE TTimeForm.Button1Click(Sender: TObject);
VAR
    bE: Boolean;
    nI: Integer;
BEGIN
    IF (Length(Edit1.Text) = 0) THEN
    BEGIN
        wError('Missing time.');
        ActiveControl := Edit1;
        EXIT;
    END;

    bE := FALSE;
    FOR nI := 1 TO Length(Edit1.Text) DO
    BEGIN
        IF ((Edit1.Text[nI] < '0') OR (Edit1.Text[nI] > '9')) THEN
        BEGIN
            bE := TRUE;
            BREAK;
        END;
    END;
    IF (bE) THEN
    BEGIN
        wError('Time can only consist of numeric digits.');
        ActiveControl := Edit1;
        EXIT;
    END;

    IF (Length(Edit2.Text) = 0) THEN
    BEGIN
        wError('Missing increment.');
        ActiveControl := Edit2;
        EXIT;
    END;

    bE := FALSE;
    FOR nI := 1 TO Length(Edit2.Text) DO
    BEGIN
        IF ((Edit2.Text[nI] < '0') OR (Edit2.Text[nI] > '9')) THEN
        BEGIN
            bE := TRUE;
            BREAK;
        END;
    END;
    IF (bE) THEN
    BEGIN
        wError('Increment can only consist of numeric digits.');
        ActiveControl := Edit2;
        EXIT;
    END;

    bOK       := TRUE;
    cNewTimeC := IntToStr(StrToInt(Edit1.Text)) + '+' + IntToStr(StrToInt(Edit2.Text));

    Close;
END;

PROCEDURE TTimeForm.Button2Click(Sender: TObject);
BEGIN
    bOK := FALSE;
    Close;
END;

PROCEDURE TTimeForm.Button3Click(Sender: TObject);
BEGIN
    Edit1.Text := DEFAULT_TIME;
    Edit2.Text := DEFAULT_INC;
END;

END.
