(*============================================================================*)
(* HANDLE.PAS -- Edit handle window                                           *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.03: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)
UNIT HANDLE;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, Buttons,
    MISC,global;


TYPE
    THandleForm = CLASS(TForm)
        Label1: TLabel;
        Label2: TLabel;
        Label3: TLabel;

        Edit1:  TEdit;

        Button1: TButton;
        Button2: TButton;
    Edit2: TEdit;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE SetupValues;
        PROCEDURE Button1Click(Sender: TObject);
        PROCEDURE Button2Click(Sender: TObject);
        PROCEDURE Edit1Exit(Sender: TObject);

        PRIVATE
        { Private declarations }
        PUBLIC
        { Public declarations }
        bOK:        Boolean;
        cOrgHandle: String;
        cNewHandle: String;
    END;


IMPLEMENTATION

{$R *.DFM}

PROCEDURE THandleForm.FormCreate(Sender: TObject);
BEGIN
    Left       := (Screen.Width  - Width ) SHR 1;
    Top        := (Screen.Height - Height) SHR 1;
    cOrgHandle := '';
    cNewHandle := '';
END;

PROCEDURE THandleForm.SetupValues;
BEGIN
    bOK            := FALSE;
    ActiveControl  := Edit1;
    if edit2.Visible then label2.Visible:=false;
    edit2.Text := cOrgHandle;
    label2.Caption:=cOrgHandle;
    Edit1.Text     := cNewHandle;
END;

PROCEDURE THandleForm.Edit1Exit(Sender: TObject);
BEGIN
    Edit1.Text := Trim(Edit1.Text);
    IF (Length(Edit1.Text) > FICS_NAME_LEN) THEN
        Edit1.Text := Copy(Edit1.Text,1,FICS_NAME_LEN);
END;

PROCEDURE THandleForm.Button1Click(Sender: TObject);
VAR
    bE: Boolean;
    nI: Integer;
BEGIN
    IF (Length(Edit1.Text) = 0) THEN
    BEGIN
        wError('Missing handle.');
        ActiveControl := Edit1;
        EXIT;
    END;
    IF ((edit2.Visible) and (length(edit2.Text)=0)) then
    begin
     wError('Missing handle.');
     ActiveControl:=Edit2;
     exit;
    end;

    bE := FALSE;
    FOR nI := 1 TO Length(Edit1.Text) DO
    BEGIN
        IF ((UpCase(Edit1.Text[nI]) < 'A') OR (UpCase(Edit1.Text[nI]) > 'Z')) THEN
        BEGIN
            bE := TRUE;
            BREAK;
        END;
    END;
    IF (bE) THEN
    BEGIN
        wError('Handle can only consist of lower and upper case letters.');
        ActiveControl := Edit1;
        EXIT;
    END;

    bOK := TRUE;
    IF (Length(Edit1.Text) > FICS_NAME_LEN) THEN
        cNewHandle := Trim(Copy(Edit1.Text,1,FICS_NAME_LEN))
    ELSE
        cNewHandle := Edit1.Text;
    Close;
END;

PROCEDURE THandleForm.Button2Click(Sender: TObject);
BEGIN
    bOK := FALSE;
    Close;
END;

END.
