(*============================================================================*)
(* KEYMAP.PAS -- Edit chess font keymap window                                *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2002-2005 Fermy                          *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.21: First construction.                                            *)
(* 1998.11.22: 1) Fixed some wrong label (should be black instead of white).  *)
(*             2) Changed the chess font keymap to hold up to 2 characters.   *)
(* 2005.02.15: Added Move indicator                                                                           *)
(*============================================================================*)
UNIT KEYMAP;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, ComCtrls, ExtCtrls,
    GLOBAL,INI1,misc;


TYPE
    TKeyMapForm = CLASS(TForm)
        Label1:  TLabel;
        Edit1:   TEdit;
        Label2:  TLabel;
        Edit2:   TEdit;
        Label3:  TLabel;
        Edit3:   TEdit;
        Label4:  TLabel;
        Edit4:   TEdit;
        Label5:  TLabel;
        Edit5:   TEdit;
        Label6:  TLabel;
        Edit6:   TEdit;
        Label7:  TLabel;
        Edit7:   TEdit;
        Label8:  TLabel;
        Edit8:   TEdit;
        Label9:  TLabel;
        Edit9:   TEdit;
        Label10: TLabel;
        Edit10:  TEdit;
        Label11: TLabel;
        Edit11:  TEdit;
        Label12: TLabel;
        Edit12:  TEdit;
        Label13: TLabel;
        Edit13:  TEdit;
        Label14: TLabel;
        Edit14:  TEdit;
        Label15: TLabel;
        Edit15:  TEdit;
        Label16: TLabel;
        Edit16:  TEdit;
        Label17: TLabel;
        Edit17:  TEdit;
        Label18: TLabel;
        Edit18:  TEdit;
        Label19: TLabel;
        Edit19:  TEdit;
        Label20: TLabel;
        Edit20:  TEdit;
        Label21: TLabel;
        Edit21:  TEdit;
        Label22: TLabel;
        Edit22:  TEdit;
        Label23: TLabel;
        Edit23:  TEdit;
        Label24: TLabel;
        Edit24:  TEdit;
        Label25: TLabel;
        Edit25:  TEdit;
        Label26: TLabel;
        Edit26:  TEdit;
        Label27: TLabel;
        Edit27:  TEdit;
        Label28: TLabel;
        Edit28:  TEdit;
        Label29: TLabel;
        Edit29:  TEdit;
        Label30: TLabel;
        Edit30:  TEdit;
        Label31: TLabel;
        Edit31:  TEdit;
        Label32: TLabel;
        Edit32:  TEdit;
        Label33: TLabel;
        Edit33:  TEdit;
        Label34: TLabel;
        Edit34:  TEdit;

        Button98:  TButton;
        Button99:  TButton;
        Button100: TButton;
    Label35: TLabel;
    Edit35: TEdit;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE SetupValues;
        PROCEDURE Button98Click(Sender: TObject);
        PROCEDURE Button99Click(Sender: TObject);
        PROCEDURE Button100Click(Sender: TObject);

        PRIVATE
        { Private declarations }

        PUBLIC
        { Public declarations }
    END;

IMPLEMENTATION

{$R *.DFM}

PROCEDURE TKeyMapForm.FormCreate(Sender: TObject);
BEGIN
//    Werror('Creating Key map form');
    Left    := (Screen.Width  - Width ) SHR 1;
    Top     := (Screen.Height - Height) SHR 1;
    Caption := 'Edit chess font keymap';
END;

PROCEDURE TKeyMapForm.SetupValues;
BEGIN
    ActiveControl := Edit1;

    Edit1.Text  := INI1.INI.cWPWS;
    Edit2.Text  := INI1.INI.cWPBS;
    Edit3.Text  := INI1.INI.cWNWS;
    Edit4.Text  := INI1.INI.cWNBS;
    Edit5.Text  := INI1.INI.cWBWS;
    Edit6.Text  := INI1.INI.cWBBS;
    Edit7.Text  := INI1.INI.cWRWS;
    Edit8.Text  := INI1.INI.cWRBS;
    Edit9.Text  := INI1.INI.cWQWS;
    Edit10.Text := INI1.INI.cWQBS;
    Edit11.Text := INI1.INI.cWKWS;
    Edit12.Text := INI1.INI.cWKBS;

    Edit13.Text := INI1.INI.cBPWS;
    Edit14.Text := INI1.INI.cBPBS;
    Edit15.Text := INI1.INI.cBNWS;
    Edit16.Text := INI1.INI.cBNBS;
    Edit17.Text := INI1.INI.cBBWS;
    Edit18.Text := INI1.INI.cBBBS;
    Edit19.Text := INI1.INI.cBRWS;
    Edit20.Text := INI1.INI.cBRBS;
    Edit21.Text := INI1.INI.cBQWS;
    Edit22.Text := INI1.INI.cBQBS;
    Edit23.Text := INI1.INI.cBKWS;
    Edit24.Text := INI1.INI.cBKBS;

    Edit25.Text := INI1.INI.cWS;
    Edit26.Text := INI1.INI.cBS;

    Edit27.Text := INI1.INI.cTopLC;
    Edit28.Text := INI1.INI.cTopB;
    Edit29.Text := INI1.INI.cTopRC;

    Edit30.Text := INI1.INI.cLeftB;
    Edit31.Text := INI1.INI.cRightB;

    Edit32.Text := INI1.INI.cBotLC;
    Edit33.Text := INI1.INI.cBotB;
    Edit34.Text := INI1.INI.cBotRC;
    Edit35.Text := ini1.INI.cMoveInd;
END;

PROCEDURE TKeyMapForm.Button98Click(Sender: TObject);
BEGIN
    IF (Length(Edit1.Text) > 2)  THEN Edit1.Text  := Copy(Edit1.Text,1,2);
    IF (Length(Edit2.Text) > 2)  THEN Edit2.Text  := Copy(Edit2.Text,1,2);
    IF (Length(Edit3.Text) > 2)  THEN Edit3.Text  := Copy(Edit3.Text,1,2);
    IF (Length(Edit4.Text) > 2)  THEN Edit4.Text  := Copy(Edit4.Text,1,2);
    IF (Length(Edit5.Text) > 2)  THEN Edit5.Text  := Copy(Edit5.Text,1,2);
    IF (Length(Edit6.Text) > 2)  THEN Edit6.Text  := Copy(Edit6.Text,1,2);
    IF (Length(Edit7.Text) > 2)  THEN Edit7.Text  := Copy(Edit7.Text,1,2);
    IF (Length(Edit8.Text) > 2)  THEN Edit8.Text  := Copy(Edit8.Text,1,2);
    IF (Length(Edit9.Text) > 2)  THEN Edit9.Text  := Copy(Edit9.Text,1,2);
    IF (Length(Edit10.Text) > 2) THEN Edit10.Text := Copy(Edit10.Text,1,2);
    IF (Length(Edit11.Text) > 2) THEN Edit11.Text := Copy(Edit11.Text,1,2);
    IF (Length(Edit12.Text) > 2) THEN Edit12.Text := Copy(Edit12.Text,1,2);
    IF (Length(Edit13.Text) > 2) THEN Edit13.Text := Copy(Edit13.Text,1,2);
    IF (Length(Edit14.Text) > 2) THEN Edit14.Text := Copy(Edit14.Text,1,2);
    IF (Length(Edit15.Text) > 2) THEN Edit15.Text := Copy(Edit15.Text,1,2);
    IF (Length(Edit16.Text) > 2) THEN Edit16.Text := Copy(Edit16.Text,1,2);
    IF (Length(Edit17.Text) > 2) THEN Edit17.Text := Copy(Edit17.Text,1,2);
    IF (Length(Edit18.Text) > 2) THEN Edit18.Text := Copy(Edit18.Text,1,2);
    IF (Length(Edit19.Text) > 2) THEN Edit19.Text := Copy(Edit19.Text,1,2);
    IF (Length(Edit20.Text) > 2) THEN Edit20.Text := Copy(Edit20.Text,1,2);
    IF (Length(Edit21.Text) > 2) THEN Edit21.Text := Copy(Edit21.Text,1,2);
    IF (Length(Edit22.Text) > 2) THEN Edit22.Text := Copy(Edit22.Text,1,2);
    IF (Length(Edit23.Text) > 2) THEN Edit23.Text := Copy(Edit23.Text,1,2);
    IF (Length(Edit24.Text) > 2) THEN Edit24.Text := Copy(Edit24.Text,1,2);
    IF (Length(Edit25.Text) > 2) THEN Edit25.Text := Copy(Edit25.Text,1,2);
    IF (Length(Edit26.Text) > 2) THEN Edit26.Text := Copy(Edit26.Text,1,2);
    IF (Length(Edit27.Text) > 2) THEN Edit27.Text := Copy(Edit27.Text,1,2);
    IF (Length(Edit28.Text) > 2) THEN Edit28.Text := Copy(Edit28.Text,1,2);
    IF (Length(Edit29.Text) > 2) THEN Edit29.Text := Copy(Edit29.Text,1,2);
    IF (Length(Edit30.Text) > 2) THEN Edit30.Text := Copy(Edit30.Text,1,2);
    IF (Length(Edit31.Text) > 2) THEN Edit31.Text := Copy(Edit31.Text,1,2);
    IF (Length(Edit32.Text) > 2) THEN Edit32.Text := Copy(Edit32.Text,1,2);
    IF (Length(Edit33.Text) > 2) THEN Edit33.Text := Copy(Edit33.Text,1,2);
    IF (Length(Edit34.Text) > 2) THEN Edit34.Text := Copy(Edit34.Text,1,2);

    INI1.INI.cWPWS := Edit1.Text;
    INI1.INI.cWPBS := Edit2.Text;
    INI1.INI.cWNWS := Edit3.Text;
    INI1.INI.cWNBS := Edit4.Text;
    INI1.INI.cWBWS := Edit5.Text;
    INI1.INI.cWBBS := Edit6.Text;
    INI1.INI.cWRWS := Edit7.Text;
    INI1.INI.cWRBS := Edit8.Text;
    INI1.INI.cWQWS := Edit9.Text;
    INI1.INI.cWQBS := Edit10.Text;
    INI1.INI.cWKWS := Edit11.Text;
    INI1.INI.cWKBS := Edit12.Text;

    INI1.INI.cBPWS := Edit13.Text;
    INI1.INI.cBPBS := Edit14.Text;
    INI1.INI.cBNWS := Edit15.Text;
    INI1.INI.cBNBS := Edit16.Text;
    INI1.INI.cBBWS := Edit17.Text;
    INI1.INI.cBBBS := Edit18.Text;
    INI1.INI.cBRWS := Edit19.Text;
    INI1.INI.cBRBS := Edit20.Text;
    INI1.INI.cBQWS := Edit21.Text;
    INI1.INI.cBQBS := Edit22.Text;
    INI1.INI.cBKWS := Edit23.Text;
    INI1.INI.cBKBS := Edit24.Text;

    INI1.INI.cWS := Edit25.Text;
    INI1.INI.cBS := Edit26.Text;

    INI1.INI.cTopLC := Edit27.Text;
    INI1.INI.cTopB  := Edit28.Text;
    INI1.INI.cTopRC := Edit29.Text;

    INI1.INI.cLeftB  := Edit30.Text;
    INI1.INI.cRightB := Edit31.Text;

    INI1.INI.cBotLC := Edit32.Text;
    INI1.INI.cBotB  := Edit33.Text;
    INI1.INI.cBotRC := Edit34.Text;
    Ini1.INI.cMoveInd:=Edit35.Text;

    Close;
END;

PROCEDURE TKeyMapForm.Button99Click(Sender: TObject);
BEGIN
    Close;
END;

PROCEDURE TKeyMapForm.Button100Click(Sender: TObject);
BEGIN
    Edit1.Text  := 'p';
    Edit2.Text  := 'P';
    Edit3.Text  := 'n';
    Edit4.Text  := 'N';
    Edit5.Text  := 'b';
    Edit6.Text  := 'B';
    Edit7.Text  := 'r';
    Edit8.Text  := 'R';
    Edit9.Text  := 'q';
    Edit10.Text := 'Q';
    Edit11.Text := 'k';
    Edit12.Text := 'K';

    Edit13.Text := 'o';
    Edit14.Text := 'O';
    Edit15.Text := 'm';
    Edit16.Text := 'M';
    Edit17.Text := 'v';
    Edit18.Text := 'V';
    Edit19.Text := 't';
    Edit20.Text := 'T';
    Edit21.Text := 'w';
    Edit22.Text := 'W';
    Edit23.Text := 'l';
    Edit24.Text := 'L';

    Edit25.Text := '*';
    Edit26.Text := '+';

    Edit27.Text := '!';
    Edit28.Text := '"';
    Edit29.Text := '#';

    Edit30.Text := '$';
    Edit31.Text := '%';

    Edit32.Text := '/';
    Edit33.Text := '(';
    Edit34.Text := ')';
END;

END.
