(*============================================================================*)
(* NEXTMOVE.PAS -- Next move window                                           *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.03: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)
UNIT NEXTMOVE;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls,
    GLOBAL, TOOLBOX,INI1,misc;


TYPE
    TNextMoveForm = CLASS(TForm)
        ListBox1: TListBox;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE ClearAll;
        PROCEDURE ResetAll;
        FUNCTION  AddItem(cItem: String): Integer;

        PRIVATE
        { Private declarations }

        PUBLIC
        { Public declarations }
    END;

VAR
    NextMoveForm: TNextMoveForm;

IMPLEMENTATION

{$R *.DFM}

PROCEDURE TNextMoveForm.FormCreate(Sender: TObject);
BEGIN
//    Werror('Creating Next move form');
    ListBox1.Color       := INI1.INI.nNextMoveB;
    ListBox1.Font.Color  := INI1.INI.fNextMoveF.Color;
    ListBox1.Font.Height := INI1.INI.fNextMoveF.Height;
    ListBox1.Font.Name   := INI1.INI.fNextMoveF.Name;
    ListBox1.Font.Pitch  := INI1.INI.fNextMoveF.Pitch;
    ListBox1.Font.Size   := INI1.INI.fNextMoveF.Size;
    ListBox1.Font.Style  := INI1.INI.fNextMoveF.Style;

    ResetAll;

    IF (INI1.INI.nNextMoveS <> 2) THEN
    BEGIN
        SetBounds(INI1.INI.nNextMoveL, INI1.INI.nNextMoveT,
                  INI1.INI.nNextMoveW, INI1.INI.nNextMoveH);
    END;
    WindowState := TOOLBOX_IntToWinState(INI1.INI.nNextMoveS);
    Caption     := 'Next move';
END;

PROCEDURE TNextMoveForm.ClearAll;
BEGIN
    ListBox1.Items.Clear;
    ListBox1.ItemIndex := -1;
END;

PROCEDURE TNextMoveForm.ResetAll;
BEGIN
    ListBox1.Enabled := FALSE;
    ClearAll;
END;

FUNCTION TNextMoveForm.AddItem(cItem: String): Integer;
BEGIN
    IF (ListBox1.Items.Count < MAX_NEXT) THEN
    BEGIN
        ListBox1.Items.Add(cItem);
        Result := ListBox1.Items.Count;
    END
    ELSE
        Result := -1;
END;

END.
