(*============================================================================*)
(* PICKDIR.PAS -- Pick directory window                                       *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.09: First construction.                                            *)
(* 1998.11.13: Made this window into a system window (with close button).     *)
(*                                                                            *)
(*============================================================================*)
UNIT PICKDIR;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, FileCtrl,misc;

TYPE
    TPickDirForm = CLASS(TForm)
        DriveComboBox1:    TDriveComboBox;
        DirectoryListBox1: TDirectoryListBox;

        Button1: TButton;
        Button2: TButton;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE SetupValues;
        PROCEDURE Button1Click(Sender: TObject);
        PROCEDURE Button2Click(Sender: TObject);

        PRIVATE
        { Private declarations }

        PUBLIC
        { Public declarations }
        bOK:      Boolean;
        cOrgPath: String;
        cNewPath: String;
    END;

VAR
    PickDirForm: TPickDirForm;

IMPLEMENTATION

{$R *.DFM}

PROCEDURE TPickDirForm.FormCreate(Sender: TObject);
BEGIN
//    Werror('Creating Pick Dir form');
    Left     := (Screen.Width  - Width ) SHR 1;
    Top      := (Screen.Height - Height) SHR 1;
    cOrgPath := '';
    cNewPath := '';
END;

PROCEDURE TPickDirForm.SetupValues;
VAR
    cDrv, cDir: String;
BEGIN
    bOK           := FALSE;
    ActiveControl := DriveComboBox1;

    cDrv := ExtractFileDrive(cOrgPath);
    cDir := ExtractFilePath(cOrgPath);

    IF (Length(cDrv) = 0) THEN
        cDrv := ExtractFileDrive(ExtractFilePath(ParamStr(0)));

    TRY
        DriveComboBox1.Drive        := cDrv[1];
        DirectoryListBox1.Drive     := cDrv[1];
        DirectoryListBox1.Directory := cDir;
    EXCEPT
        ON E: EInOutError DO
        BEGIN
            cDrv := ExtractFileDrive(ExtractFilePath(ParamStr(0)));

            DriveComboBox1.Drive        := cDrv[1];
            DirectoryListBox1.Drive     := cDrv[1];
            DirectoryListBox1.Directory := ExtractFilePath(ParamStr(0));
        END;
    END;
END;

PROCEDURE TPickDirForm.Button1Click(Sender: TObject);
VAR
    nL: Integer;
BEGIN
    bOK      := TRUE;
    cNewPath := DirectoryListBox1.Directory;

    nL := Length(cNewPath);
    IF (nL > 0) THEN
    BEGIN
        IF (cNewPath[nL] <> '\') THEN
            cNewPath := cNewPath + '\';
    END;

    Close;
END;

PROCEDURE TPickDirForm.Button2Click(Sender: TObject);
BEGIN
    bOK := FALSE;
    Close;
END;

END.
