(*============================================================================*)
(* PROMOTE.PAS -- Piece promote selection window                              *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.03: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)
UNIT PROMOTE;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls,misc;

TYPE
    TfPromote = CLASS(TForm)
        RadioButton1: TRadioButton;
        RadioButton2: TRadioButton;
        RadioButton3: TRadioButton;
        RadioButton4: TRadioButton;

        PROCEDURE FormCreate  (Sender: TObject);
        PROCEDURE FormActivate(Sender: TObject);
        PROCEDURE FormShow    (Sender: TObject);

        PROCEDURE RadioButton1Click(Sender: TObject);
        PROCEDURE RadioButton2Click(Sender: TObject);
        PROCEDURE RadioButton3Click(Sender: TObject);
        PROCEDURE RadioButton4Click(Sender: TObject);

    PRIVATE
        { Private declarations }
    PUBLIC
        { Public declarations }
        nSelect:  Integer;
        nLeft:    Integer;
        nTop:     Integer;
    END;


IMPLEMENTATION

{$R *.DFM}

PROCEDURE TfPromote.FormCreate(Sender: TObject);
BEGIN
//    Werror('Creating promote form');
    Width := 100;
    Left  := ((Screen.Width  - Width)  DIV 2);
    Top   := ((Screen.Height - Height) DIV 2);
    nLeft := Left;
    nTop  := Top;
END;

PROCEDURE TfPromote.FormActivate(Sender: TObject);
BEGIN
    ActiveControl := RadioButton1;

    nSelect := 0;

    RadioButton1.Checked := FALSE;
    RadioButton2.Checked := FALSE;
    RadioButton3.Checked := FALSE;
    RadioButton4.Checked := FALSE;
END;

PROCEDURE TfPromote.FormShow(Sender: TObject);
BEGIN
    Left := nLeft;
    Top  := nTop;
END;

PROCEDURE TfPromote.RadioButton1Click(Sender: TObject);
BEGIN
    nSelect := 1;
    Close;
END;

PROCEDURE TfPromote.RadioButton2Click(Sender: TObject);
BEGIN
    nSelect := 2;
    Close;
END;

PROCEDURE TfPromote.RadioButton3Click(Sender: TObject);
BEGIN
    nSelect := 3;
    Close;
END;

PROCEDURE TfPromote.RadioButton4Click(Sender: TObject);
BEGIN
    nSelect := 4;
    Close;
END;

END.
