(*============================================================================*)
(* RATING.PAS -- Edit rating window                                           *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.03: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)
UNIT RATING;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, Buttons,
    MISC,global;


TYPE
    TRatingForm = CLASS(TForm)
        Label1: TLabel;
        Label2: TLabel;
        Label3: TLabel;

        Edit1:  TEdit;

        Button1: TButton;
        Button2: TButton;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE SetupValues;
        PROCEDURE Button1Click(Sender: TObject);
        PROCEDURE Button2Click(Sender: TObject);
        PROCEDURE Edit1Exit(Sender: TObject);

        PRIVATE
        { Private declarations }
        PUBLIC
        { Public declarations }
        bOK:        Boolean;
        cOrgRating: String;
        cNewRating: String;
    END;


IMPLEMENTATION

{$R *.DFM}

PROCEDURE TRatingForm.FormCreate(Sender: TObject);
BEGIN
    Left       := (Screen.Width  - Width ) SHR 1;
    Top        := (Screen.Height - Height) SHR 1;
    cOrgRating := '';
    cNewRating := '';
END;

PROCEDURE TRatingForm.SetupValues;
BEGIN
    bOK            := FALSE;
    ActiveControl  := Edit1;
    Label2.Caption := cOrgRating;
    Edit1.Text     := cNewRating;
END;

PROCEDURE TRatingForm.Edit1Exit(Sender: TObject);
BEGIN
    Edit1.Text := Trim(Edit1.Text);
    IF (Length(Edit1.Text) > 4) THEN
        Edit1.Text := Copy(Edit1.Text,1,4);
END;

PROCEDURE TRatingForm.Button1Click(Sender: TObject);
VAR
    bE: Boolean;
    nI: Integer;
BEGIN
    IF (Length(Edit1.Text) > 0) THEN
    BEGIN
        IF (CompareText(Edit1.Text,'++++') = 0) THEN
        BEGIN
        END
        ELSE
        IF (CompareText(Edit1.Text,'----') = 0) THEN
        BEGIN
        END
        ELSE
        BEGIN
            bE := FALSE;
            FOR nI := 1 TO Length(Edit1.Text) DO
            BEGIN
                IF ((Edit1.Text[nI] < '0') OR (Edit1.Text[nI] > '9')) THEN
                BEGIN
                    bE := TRUE;
                    BREAK;
                END;
            END;
            IF (bE) THEN
            BEGIN
                wError('Rating can only be ++++, ----, or any numeric value range from 0 to 9999.');
                ActiveControl := Edit1;
                EXIT;
            END;
        END;
    END;

    bOK := TRUE;
    IF (Length(Edit1.Text) > 4) THEN
        cNewRating := Trim(Copy(Edit1.Text,1,4))
    ELSE
        cNewRating := Edit1.Text;
    Close;
END;

PROCEDURE TRatingForm.Button2Click(Sender: TObject);
BEGIN
    bOK := FALSE;
    Close;
END;

END.
