(*============================================================================*)
(* sjeng.PAS -- Misc Engine parsing related functions                         *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2002 Fermy                               *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 2002.01.01: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)

unit Sjeng;

interface
function SjengFilterOutput(s:string):string;
function SjengMove(s:string;mnum:integer):string;
function noFilter(s:string):string;
function parsenum(var s:string; d:string):string;

implementation
uses sysutils;

function SjengMove(s:string;mnum:integer):string;
var ps:integer;
s1,s2:string;
begin
 ps:=pos('@',s);
 if ps>0 then
 begin
  if odd(mnum) then s1:=UpperCase(s[ps-1])
  else s1:=lowercase(s[ps-1]);
  s:=s1+copy(s,ps,length(s));
 end;
 ps:=pos('=',s);
 if ps>0 then
 begin
  if odd(mnum) then s1:=UpperCase(s[ps+1])
  else s1:=lowercase(s[ps+1]);
  s:=copy(s,1,ps)+s1;
 end;
 Result:=s;
end;


function Parsenum(var s:string;d:string):string;
var ps,cd,num:integer;
s1:string;
begin
 s:=trim(s);
 ps:=pos(d,s);
 if ps>0 then
 begin
  s1:=copy(s,1,ps-1);
  s1:=trim(s1);
  val(s1,num,cd);
  if cd<>0 then s1:='error'  //not a number
  else delete(s,1,ps);  //s1 is a number, we delete s1 from s;
 end
 else begin
  val(s,num,cd);
  if cd<>0 then s1:='error' else begin s1:=s;s:='';end;
 end;
 Result:=s1;
end;

function SjengFilterOutput(s:string):string;
var s1,s2,s3,s4,res,sep:string;
begin
sep:=' ';
 s1:=parseNum(s,' ');
 s2:=parseNum(s,' ');
 s3:=parsenum(s,' ');
 s4:=parsenum(s,' ');
 if ((s1='error') or (s2='error') or (s3='error') or (s4='error')) then res:=''
 else res:='Score='+s2+sep+'Depth='+s1+sep+'Line='+s;
 result:=res;
end;

function noFilter(s:string):string;
begin
 Result:=s;
end;
end.
