(*============================================================================*)
(* soundopt.PAS -- Sound Option Form                                          *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2002 Fermy                               *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 2002.01.10: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)

unit Soundopt;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SRLabel, SRWave, Grids, Buttons;

const sep=': ';
MAX_SEVENT=3;

type
  TSoundForm = class(TForm)
    Button1: TSpeedButton;
    Button2: TSpeedButton;
    Button3: TSpeedButton;
    Button4: TSpeedButton;
    Button5: TSpeedButton;
    Button6: TSpeedButton;
    SRLabel1: TSRLabel;
    Open1: TOpenDialog;
    SRWave1: TSRWavePlayer;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Edit1Enter(Sender: TObject);
  private
    { Private declarations }
  public
   bok:boolean;
   lasted:^TEdit;
//  Sevents:array[0..MAX_SEVENT] of string;
   procedure setupvalues;

    { Public declarations }
  end;

var
  SoundForm: TSoundForm;

implementation

{$R *.DFM}

procedure Tsoundform.setupvalues;
begin
 ActiveControl:=edit1;
end;

procedure TSoundForm.Button2Click(Sender: TObject);
begin
 bok:=false;
 close;
end;

procedure TSoundForm.Button3Click(Sender: TObject);
begin
 if open1.execute then
 begin
  with ActiveControl as Tedit do text:=open1.FileName;
 end;
end;

procedure TSoundForm.Button1Click(Sender: TObject);
begin
 bok:=true;
 close;
end;


procedure TSoundForm.Button4Click(Sender: TObject);
begin
 with activecontrol as tedit do srwave1.wavename:=text;
 if lowercase(srwave1.wavename)='none' then exit;
 srwave1.loop:=false;
 srwave1.async:=true;
 srwave1.play;
end;

procedure TSoundForm.Button6Click(Sender: TObject);
begin
 With ActiveControl as Tedit do text:='none';
end;

procedure TSoundForm.Button5Click(Sender: TObject);
var curdir:string;
begin
 curdir:=extractFilePath(paramstr(0));
 edit1.text:=curdir+'Sound\move';
 edit2.text:=curdir+'Sound\final';
 edit3.text:=curdir+'Sound\capture';
 edit4.text:=curdir+'Sound\check';
end;

procedure TSoundForm.Edit1Enter(Sender: TObject);
begin
 with ActiveControl as tedit do lasted:=@Activecontrol;
end;

end.
