(*============================================================================*)
(* TXTMAP.PAS -- Edit move piece keymap window (TXT)                          *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.24: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)
UNIT Txtcmap;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls, ComCtrls, ExtCtrls,
    GLOBAL,INI1,misc;


TYPE
    TTXTCMapForm = CLASS(TForm)
        Label1:  TLabel;
        Edit1:   TEdit;
        Label2:  TLabel;
        Edit2:   TEdit;
        Label3:  TLabel;
        Edit3:   TEdit;
        Label4:  TLabel;
        Edit4:   TEdit;
        Label5:  TLabel;
        Edit5:   TEdit;
        Label6:  TLabel;
        Edit6:   TEdit;
        Label7:  TLabel;
        Edit7:   TEdit;
        Label8:  TLabel;
        Edit8:   TEdit;
        Label9:  TLabel;
        Edit9:   TEdit;
        Label10: TLabel;
        Edit10:  TEdit;
        Label11: TLabel;
        Edit11:  TEdit;
        Label12: TLabel;
        Edit12:  TEdit;

        Button98:  TButton;
        Button99:  TButton;
        Button100: TButton;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE SetupValues;
        PROCEDURE Button98Click(Sender: TObject);
        PROCEDURE Button99Click(Sender: TObject);
        PROCEDURE Button100Click(Sender: TObject);

        PRIVATE
        { Private declarations }

        PUBLIC
        { Public declarations }
    END;

IMPLEMENTATION

{$R *.DFM}

PROCEDURE TTXTCMapForm.FormCreate(Sender: TObject);
BEGIN
//    Werror('Creating TXTCmap Form');
    Left    := (Screen.Width  - Width ) SHR 1;
    Top     := (Screen.Height - Height) SHR 1;
    Caption := TXTCMAP_TITLE;
END;

PROCEDURE TTXTCMapForm.SetupValues;
BEGIN
    ActiveControl := Edit1;

    Edit1.Text  := INI1.INI.cTXTCWP;
    Edit2.Text  := INI1.INI.cTXTCWN;
    Edit3.Text  := INI1.INI.cTXTCWB;
    Edit4.Text  := INI1.INI.cTXTCWR;
    Edit5.Text  := INI1.INI.cTXTCWQ;
    Edit6.Text  := INI1.INI.cTXTCWK;

    Edit7.Text  := INI1.INI.cTXTCBP;
    Edit8.Text  := INI1.INI.cTXTCBN;
    Edit9.Text  := INI1.INI.cTXTCBB;
    Edit10.Text := INI1.INI.cTXTCBR;
    Edit11.Text := INI1.INI.cTXTCBQ;
    Edit12.Text := INI1.INI.cTXTCBK;
END;

PROCEDURE TTXTCMapForm.Button98Click(Sender: TObject);
BEGIN
    IF (Length(Edit1.Text) > 2)  THEN Edit1.Text  := Copy(Edit1.Text,1,2);
    IF (Length(Edit2.Text) > 2)  THEN Edit2.Text  := Copy(Edit2.Text,1,2);
    IF (Length(Edit3.Text) > 2)  THEN Edit3.Text  := Copy(Edit3.Text,1,2);
    IF (Length(Edit4.Text) > 2)  THEN Edit4.Text  := Copy(Edit4.Text,1,2);
    IF (Length(Edit5.Text) > 2)  THEN Edit5.Text  := Copy(Edit5.Text,1,2);
    IF (Length(Edit6.Text) > 2)  THEN Edit6.Text  := Copy(Edit6.Text,1,2);

    IF (Length(Edit7.Text) > 2)  THEN Edit7.Text  := Copy(Edit7.Text,1,2);
    IF (Length(Edit8.Text) > 2)  THEN Edit8.Text  := Copy(Edit8.Text,1,2);
    IF (Length(Edit9.Text) > 2)  THEN Edit9.Text  := Copy(Edit9.Text,1,2);
    IF (Length(Edit10.Text) > 2) THEN Edit10.Text := Copy(Edit10.Text,1,2);
    IF (Length(Edit11.Text) > 2) THEN Edit11.Text := Copy(Edit11.Text,1,2);
    IF (Length(Edit12.Text) > 2) THEN Edit12.Text := Copy(Edit12.Text,1,2);

    INI1.INI.cTXTCWP := Edit1.Text;
    INI1.INI.cTXTCWN := Edit2.Text;
    INI1.INI.cTXTCWB := Edit3.Text;
    INI1.INI.cTXTCWR := Edit4.Text;
    INI1.INI.cTXTCWQ := Edit5.Text;
    INI1.INI.cTXTCWK := Edit6.Text;

    INI1.INI.cTXTCBP := Edit7.Text;
    INI1.INI.cTXTCBN := Edit8.Text;
    INI1.INI.cTXTCBB := Edit9.Text;
    INI1.INI.cTXTCBR := Edit10.Text;
    INI1.INI.cTXTCBQ := Edit11.Text;
    INI1.INI.cTXTCBK := Edit12.Text;

    Close;
END;

PROCEDURE TTXTCMapForm.Button99Click(Sender: TObject);
BEGIN
    Close;
END;

PROCEDURE TTXTCMapForm.Button100Click(Sender: TObject);
BEGIN
    Edit1.Text  := 'P';
    Edit2.Text  := 'N';
    Edit3.Text  := 'B';
    Edit4.Text  := 'R';
    Edit5.Text  := 'Q';
    Edit6.Text  := 'K';

    Edit7.Text  := '*P';
    Edit8.Text  := '*N';
    Edit9.Text  := '*B';
    Edit10.Text := '*R';
    Edit11.Text := '*Q';
    Edit12.Text := '*K';
END;

END.
