(*============================================================================*)
(* VIEWACT.PAS -- View actual text window                                     *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.05: First construction.                                            *)
(* 1998.11.06: Added an excape key to close this form.                        *)
(*                                                                            *)
(*============================================================================*)
UNIT VIEWACT;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls,
    GLOBAL,ini1;


TYPE
    TViewActualForm = CLASS(TForm)
        Memo1: TMemo;

        PROCEDURE FormCreate(Sender: TObject);
        PROCEDURE ResetAll;
        PROCEDURE Memo1KeyPress(Sender: TObject; var Key: Char);

        PRIVATE
        { Private declarations }
        PUBLIC
        { Public declarations }
    END;

IMPLEMENTATION

{$R *.DFM}

PROCEDURE TViewActualForm.FormCreate(Sender: TObject);
BEGIN
    ResetAll;
    SetBounds(INI1.INI.nVATL, INI1.INI.nVATT, INI1.INI.nVATW, INI1.INI.nVATH);
END;

PROCEDURE TViewActualForm.ResetAll;
BEGIN
    Memo1.Enabled  := TRUE;
    Memo1.ReadOnly := TRUE;
    Memo1.Clear;
END;

PROCEDURE TViewActualForm.Memo1KeyPress(Sender: TObject; VAR Key: Char);
BEGIN
    IF (Key = ESC_ASCII_CHAR) THEN
        Close;
END;

END.
