(*============================================================================*)
(* VIEWTXT.PAS -- View TXT file window                                        *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, , 2002-2005 Fermy                        *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.18: First construction.                                            *)
(*                                                                            *)
// 2005.02.22: Modified to display generic TXT file: added Setup, modified FormActivate
(*============================================================================*)
UNIT Viewtxt;

INTERFACE

USES
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    StdCtrls,
    GLOBAL,misc;


TYPE
    TViewTXTForm = CLASS(TForm)
        Memo1: TMemo;

    procedure FormActivate(Sender: TObject);
    PROCEDURE Memo1KeyPress(Sender: TObject; VAR Key: Char);
  private
    cFname:string;
    { Private declarations }
  public
    procedure Setup(cTitle,cFile:string);
    { Public declarations }
    END;


IMPLEMENTATION

{$R *.DFM}

procedure TViewTXTForm.FormActivate(Sender: TObject);
begin
 try
  memo1.Enabled  := TRUE;
  memo1.ReadOnly := TRUE;
  memo1.Lines.LoadFromFile(cFname);
 except
  Werror('Can not open file '+EOL_STR+cFname);
 end;
end;

procedure TViewTXTForm.Setup(cTitle,cFile:string);
begin
   cFname:=cFile;
   Caption:=cTitle;
end;

PROCEDURE TViewTXTForm.Memo1KeyPress(Sender: TObject; VAR Key: Char);
BEGIN
    IF (Key = ESC_ASCII_CHAR) THEN
        Close;
END;

END.
