(*============================================================================*)
(* associate.PAS -- Registry routines                                         *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2002-2005 Fermy                               *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 2002.01.22: First construction.                                            *)
(* 2005.01.29: Modified to agree with Setup of bpgnview 3.0                                                                           *)
(*============================================================================*)
unit associate;

interface
procedure associatefiles;

implementation

uses registry,windows,classes,sysutils;


procedure associatefiles;
var reg:Tregistry;
s,s1:string;
begin
 try
  reg:=Tregistry.create;
  reg.RootKey:=HKEY_CLASSES_ROOT;
  if reg.openKey('\.bpgn',true) then
  reg.writestring('','bpgnview.2');
  if reg.openKey('\.bh',true) then
  reg.writestring('','bpgnview.2');
  if reg.openKey('\bpgnview.2',true) then
  reg.writestring('','BPGN viewer v 3.0');
  if reg.openKey('\bpgnview.2\DefaultIcon',true) then
  reg.writestring('',paramstr(0)+',0');
  if reg.OpenKey('\bpgnview.2\Shell\open\command',true) then
  reg.writestring('','"'+paramstr(0)+'" /Open "%L" %1');

  Reg.RootKey:=HKEY_Local_Machine;
  if reg.openKey('\Software\Bughouse\Bpgnview',true) then
  reg.writestring('Lastver',paramstr(0));

 finally
  reg.closekey;
  reg.free;
 end;
end;


end.
