(*============================================================================*)
(* boardcfg.PAS -- Board Configuration form                                   *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2002 Fermy                               *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 2002.02.02: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)

unit boardcfg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, boardframe, RepeatBtn, LbButton, ExtCtrls,ini1,global,board,
  ExtDlgs,inifiles,toups;

type
  Tboardcfg = class(TForm)

    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ListBox4: TListBox;
    Label4: TLabel;
    ListBox5: TListBox;
    PaintBox6: TPaintBox;
    PaintBox2: TPaintBox;
    LbButton1: TLbButton;
    LbButton3: TLbButton;
    PaintBox1: TPaintBox;
    PaintBox5: TPaintBox;
    PaintBox3: TPaintBox;
    LbButton2: TLbButton;
    PaintBox4: TPaintBox;
    LbButton4: TLbButton;
    SpeedButton1: TLbButton;
    SpeedButton2: TRepeatLbButton;
    SpeedButton3: TRepeatLbButton;
    SpeedButton4: TLbButton;
    Open1: TOpenPictureDialog;
    ColorDialog1: TColorDialog;
    FontDialog1: TFontDialog;
    Save1: TSaveDialog;
    Open2: TOpenDialog;
    Destructor Destroy;
    procedure FormCreate(Sender: TObject);
    procedure PaintBox6Paint(Sender: TObject);
    procedure bgpaint;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure ListBox2KeyDown(Sender: TObject; var Key: Word;Shift:Tshiftstate);
    procedure ListBox2Enter(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    nboard8:integer;
    nspeedw:integer;
    kchanged:boolean;
  public
   bOk:boolean;

   nboardwindow:      Tcolor;
   nwhtfill:          Tcolor;
   nwhtsquare:        Tcolor;
   nwhtoutline: Tcolor;
   nwhtsoutline: Tcolor;
   nblkfill:          Tcolor;
   nblkOutline:       Tcolor;
   nblksquare:        Tcolor;
   nblkSoutline:      Tcolor;
   boutlinepc: boolean;
   boutlinebc:        Tcolor;
   nclickcolor:       Tcolor;
   nnumbercolor:      Tcolor;
   nPcSquare:         Tcolor;
   nboardoutline:     Tcolor;

   fclock:            Tfont;
   nWaitF : Tcolor;
   nWaitB : Tcolor;
   nTurnF : Tcolor;
   nTurnB : Tcolor;


   fhandle:           Tfont;
   nHandleB:          Tcolor;

   usebmpbg: boolean;
   usebmppiece:boolean;
   usebmpsquare: boolean;
   usebmptheme:boolean;

   custompiecedir:string;
   custombgdir:string;
   customboarddir:string;
   customthemedir:string;

   bmpbg: string;
   bmppiece:string;
   bmpsquare:string;
   bmptheme:string;
   tmppieces:Tpieces;
   tmpboard:Tboardbmp;
   tmpbg:Tbitmap;

   npiecesize:integer;
   npieceratio:real;
   rSqrRect:     TRect;
   bTmp:         TBitmap;
   aSqrClr:      ARRAY[1..8, 1..8] OF Integer;
   aboard: BoardArray;
   aImage:       ARRAY[1..3, 1..6] OF TBitmap;
   aSquare:      ARRAY[1..3]       OF TBitmap;
   aNum2PX:      ARRAY[0..2] OF Integer;
   aNum2PY:      ARRAY[0..2] OF Integer;
   acPiece:     ARRAY[1..2,1..8] OF Char;
   defpiecedir:string;
   defboarddir:string;
   defthemedir:string;
   defbgdir:string;

   procedure drawsquare(Tc:Tcanvas;cl:Tcolor);
   procedure displayboard;
   procedure drawboard(cv:Tcanvas);
   procedure DrawDropPc(CV: TCanvas; nBX, nBY: Integer);
   FUNCTION PieceXY(nI: Integer): Integer;
   function GetDropIndex(nBX, nBY: Integer): Integer;
   procedure DrawPiece(CV: TCanvas; nBX, nBY: Integer);
   procedure DrawPXY(CV: TCanvas; nSc, nPX, nPY: Integer; cPiece: Char);
   procedure draw5(tc:tcanvas);
   procedure initboardlist;
   procedure initpiecelist;
   procedure initbglist;
   procedure initthemelist;
   procedure loadpiece;
   procedure adjustboards;
   procedure adjustoutlines;
   procedure adjustclocks;
   procedure adjusthandles;
   procedure adjustspeeds;
   procedure adjustall;
   procedure savechanges;
   procedure changeset(n:integer);
   procedure changeboard(n:integer);
   procedure changebg(n:integer);
   procedure changetheme(n:integer);

   procedure chwsqcol;
   procedure chbsqcol;
   procedure chbbgcol;
   procedure chpolcol;
   procedure chbolcol;
   procedure chbdscol;
   procedure chcfont;
   procedure chcwfcol;
   procedure chcwbcol;
   procedure chctfcol;
   procedure chctbcol;
   procedure chhfont;
   procedure chhbgcol;
   procedure loadcustomcolors;
   procedure savecustomcolors;
   procedure loadtheme(s1:string);

    { Public declarations }
  end;
  pboardcfg=^Tboardcfg;
  function GetIndex(cPc: Char): Integer;

implementation
var
  aNum2X:       ARRAY[0..2] OF Integer = (2,4,6);
   aNum2Y:       ARRAY[0..2] OF Integer = (1,5,9);
{$R *.DFM}

function getpt(s:string):string;
var ps:integer;
begin
 ps:=pos('.',s);
 if ps>0 then Result:=copy(s,ps+2,length(s))
 else Result:=s;
end;

function nicelist(n:integer;s:string):string;
var s1,ext,s2:string;
begin
 str(n,s1);
 if n<10 then s1:='0'+s1;
 S2:=Lowercase(s);
 ext:=extractFileExt(s2);
 if ((length(ext)>0) and (length(s2)>length(ext))) then delete(s2,length(s2)-length(ext)+1,length(ext));
 s:=Uppercase(s2[1])+copy(s2,2,length(s));
 Result:=s1+'. '+s;
end;

PROCEDURE Tboardcfg.LoadCustomColors;
BEGIN
    ColorDialog1.CustomColors.Clear;

    ColorDialog1.CustomColors.Add(INI1.INI.cColorA);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorB);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorC);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorD);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorE);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorF);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorG);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorH);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorI);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorJ);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorK);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorL);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorM);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorN);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorO);
    ColorDialog1.CustomColors.Add(INI1.INI.cColorP);
END;

PROCEDURE Tboardcfg.SaveCustomColors;
BEGIN
    INI1.INI.cColorA := ColorDialog1.CustomColors.Strings[ 0];
    INI1.INI.cColorB := ColorDialog1.CustomColors.Strings[ 1];
    INI1.INI.cColorC := ColorDialog1.CustomColors.Strings[ 2];
    INI1.INI.cColorD := ColorDialog1.CustomColors.Strings[ 3];
    INI1.INI.cColorE := ColorDialog1.CustomColors.Strings[ 4];
    INI1.INI.cColorF := ColorDialog1.CustomColors.Strings[ 5];
    INI1.INI.cColorG := ColorDialog1.CustomColors.Strings[ 6];
    INI1.INI.cColorH := ColorDialog1.CustomColors.Strings[ 7];
    INI1.INI.cColorI := ColorDialog1.CustomColors.Strings[ 8];
    INI1.INI.cColorJ := ColorDialog1.CustomColors.Strings[ 9];
    INI1.INI.cColorK := ColorDialog1.CustomColors.Strings[10];
    INI1.INI.cColorL := ColorDialog1.CustomColors.Strings[11];
    INI1.INI.cColorM := ColorDialog1.CustomColors.Strings[12];
    INI1.INI.cColorN := ColorDialog1.CustomColors.Strings[13];
    INI1.INI.cColorO := ColorDialog1.CustomColors.Strings[14];
    INI1.INI.cColorP := ColorDialog1.CustomColors.Strings[15];
END;


procedure tboardcfg.chwsqcol;
begin
 LoadCustomColors;
 ColorDialog1.Color := nwhtsquare;
    IF (ColorDialog1.Execute) THEN
    BEGIN
        SaveCustomColors;
        nWhtsquare := ColorDialog1.Color;
        if not usebmpsquare then
        begin
         loadpiece;
         paintbox1.repaint;
        end;
    END;
end;

procedure tboardcfg.chbsqcol;
begin
 LoadCustomColors;
 ColorDialog1.Color := nblksquare;
    IF (ColorDialog1.Execute) THEN
    BEGIN
        SaveCustomColors;
        nblksquare := ColorDialog1.Color;
        if not usebmpsquare then
        begin
         loadpiece;
         paintbox1.repaint;
        end;
    END;

end;

procedure tboardcfg.chbbgcol;
begin
 LoadCustomColors;
 ColorDialog1.Color := paintbox6.Color;
    IF (ColorDialog1.Execute) THEN
    BEGIN
        SaveCustomColors;
        paintbox6.color := ColorDialog1.Color;
        if not usebmpbg then
        begin
         loadpiece;
         paintbox1.repaint;
        end;
    END;

end;

procedure tboardcfg.chpolcol;
begin
  LoadCustomColors;
  ColorDialog1.Color := nnumbercolor;
    IF (ColorDialog1.Execute) THEN
    BEGIN
        SaveCustomColors;
        nnumbercolor := ColorDialog1.Color;
        paintbox1.Invalidate;
    end;

end;

procedure tboardcfg.chbolcol;
begin
 LoadCustomColors;
 ColorDialog1.Color := nboardoutline;
    IF (ColorDialog1.Execute) THEN
    BEGIN
        SaveCustomColors;
        nboardoutline:= ColorDialog1.Color;
        displayboard;
    END;

end;

procedure tboardcfg.chbdscol;
begin
 LoadCustomColors;
 ColorDialog1.Color := npcsquare;
    IF (ColorDialog1.Execute) THEN
    BEGIN
        SaveCustomColors;
        npcsquare := ColorDialog1.Color;
        if not usebmpbg then
        begin
         loadpiece;
         paintbox1.repaint;
        end;
    END;

end;

procedure tboardcfg.chcfont;
BEGIN
    FontDialog1.Device     := fdScreen;
    FontDialog1.Font       := fclock;
    FontDialog1.Font.Color := nwaitf;
    IF (FontDialog1.Execute) THEN
    BEGIN
        fclock:=fontdialog1.font;
        Lbbutton3.setfont(fclock);
        lbbutton3.Font.Color := nwaitf;
        lbbutton4.setfont(fclock);
        Lbbutton4.Font.Color := nturnf;
        adjustclocks;
    END;

end;

procedure tboardcfg.chcwfcol;
begin
 LoadCustomColors;
 ColorDialog1.Color := nwaitf;
    IF (ColorDialog1.Execute) THEN
    BEGIN
        SaveCustomColors;
        nwaitf := ColorDialog1.Color;
        lbbutton3.Font.color:=nwaitF;
    END;

end;

procedure tboardcfg.chcwbcol;
begin
 LoadCustomColors;
 ColorDialog1.Color := nwaitb;
    IF (ColorDialog1.Execute) THEN
    BEGIN
        SaveCustomColors;
        nwaitb := ColorDialog1.Color;
        lbbutton3.Color:=nwaitb;
    END;

end;

procedure tboardcfg.chctfcol;
begin
 LoadCustomColors;
 ColorDialog1.Color := nturnf;
    IF (ColorDialog1.Execute) THEN
    BEGIN
        SaveCustomColors;
        nturnf := ColorDialog1.Color;
        lbbutton4.Font.color:=nturnf;
    END;

end;

procedure tboardcfg.chctbcol;
begin
 LoadCustomColors;
 ColorDialog1.Color := nturnb;
    IF (ColorDialog1.Execute) THEN
    BEGIN
        SaveCustomColors;
        nturnb := ColorDialog1.Color;
        lbbutton4.color:=nturnb;
    END;

end;

procedure tboardcfg.chhfont;
begin

    FontDialog1.Device     := fdScreen;
    FontDialog1.Font       := fhandle;
    IF (FontDialog1.Execute) THEN
    BEGIN
        Lbbutton1.setfont(FontDialog1.Font);
        lbbutton2.setfont(FontDialog1.Font);
        fhandle:=fontdialog1.font;
        adjusthandles;
    END;


end;

procedure tboardcfg.chhbgcol;
begin
 LoadCustomColors;
 ColorDialog1.Color := nhandleb;
    IF (ColorDialog1.Execute) THEN
    BEGIN
        SaveCustomColors;
        nhandleb := ColorDialog1.Color;
        lbbutton1.color:=nhandleb;
        lbbutton2.color:=nhandleb;
    END;

end;




procedure tboardcfg.changeset(n:integer);
var s:string;
begin
 if n=0 then begin
  usebmppiece:=false;
  loadpiece;
  paintbox1.repaint;
  exit;
 end;
 if n=listbox2.items.count-1 then
 begin
  open1.Title:='Choose piece';
  open1.initialdir:=Custompiecedir;
  if open1.execute then
  begin
   s:=extractfilepath(open1.filename);
   if validpiecedir(s) then
    if readpieces(tmppieces,s) then
    begin
     usebmppiece:=true;
     custompiecedir:=s;
     bmppiece:=s;
     loadpiece;
     paintbox1.repaint;
    end;
  end;
  exit;
 end;
 s:=defpiecedir+getpt(listbox2.Items[n]+DIR_SEP);
 if validpiecedir(s) then
  if readpieces(tmppieces,s) then
  begin
   usebmppiece:=true;
   bmppiece:=s;
   loadpiece;
   paintbox1.repaint;
  end;
end;

procedure tboardcfg.changebg(n:integer);
var s:string;
begin
 if n=0 then begin
  usebmpbg:=false;
  loadpiece;
  invalidate;
  exit;
 end;
 if n=listbox4.items.count-1 then
 begin
  open1.Title:='Choose board background';
  open1.initialdir:=Custombgdir;
  if open1.execute then
  begin
   s:=extractfilepath(open1.filename);
   try
    tmpbg.loadfromfile(open1.filename);
    usebmpbg:=true;
    custombgdir:=extractfilepath(open1.filename);
    bmpbg:=open1.filename;
    loadpiece;
    invalidate;
   except

   end;

  end;
  exit;
 end;
 s:=defbgdir+getpt(listbox4.Items[n]+'.bmp');
 try
  tmpbg.LoadFromFile(s);
  usebmpbg:=true;
  bmpbg:=s;
  loadpiece;
  invalidate;
 except

 end;

end;

procedure tboardcfg.changetheme(n:integer);
var s:string;
begin
 if n=0 then exit;
 if n=listbox5.Items.count-1 then
 begin
  open2.title:='Open theme';
  open2.initialdir:=customthemedir;
  if open2.execute then
  begin
   s:=open2.filename;
   customthemedir:=extractfilepath(s);
  end
  else exit;
 end
 else s:=defthemedir+getpt(listbox5.items[n]+'.txt');
 loadtheme(s);
end;

procedure tboardcfg.changeboard(n:integer);
var s:string;
begin
 if n=0 then begin
  usebmpsquare:=false;
  loadpiece;
  paintbox1.repaint;
  exit;
 end;
 if n=listbox3.items.count-1 then
 begin
  open1.Title:='Choose board square';
  open1.initialdir:=customboarddir;
  if open1.execute then
  begin
   s:=extractfilepath(open1.filename);
   if validboarddir(s) then
    if readboard(tmpboard,s) then
    begin
     usebmpsquare:=true;
     customboarddir:=s;
     bmpsquare:=s;
     loadpiece;
     paintbox1.repaint;
    end;
  end;
  exit;
 end;
 s:=defboarddir+getpt(listbox3.Items[n]+DIR_SEP);
 if validboarddir(s) then
  if readboard(tmpboard,s) then
  begin
   usebmpsquare:=true;
   bmpsquare:=s;
   loadpiece;
   paintbox1.repaint;
  end;
end;

procedure Tboardcfg.loadtheme(s1:string);
var
tini:Tinifile;
s:string;
ctmp:string;
begin
 try
  s:='Board';
  tini:=Tinifile.create(s1);
  nwhtsquare:=tini.ReadInteger(s,'white square color',nwhtsquare);
  nblksquare:=tini.ReadInteger(s,'black square color', nblksquare);
  nnumbercolor:=tini.ReadInteger(s,'piece count color', nnumbercolor);
  paintbox6.color:=tini.ReadInteger(s,'board background color', paintbox6.color);
nboardoutline:=tini.ReadInteger(s,'board outline color', nboardoutline);
npcsquare:=tini.ReadInteger(s,'Drop Space Color', npcsquare);
nwaitf:=tini.ReadInteger(s,'clock wait foreground color', nwaitf);
nwaitb:=tini.ReadInteger(s,'clock wait background color', nwaitb);
nturnf:=tini.ReadInteger(s,'clock turn foreground color', nturnf);
nturnb:=tini.ReadInteger(s,'clock turn background color', nturnb);
nhandleb:=tini.ReadInteger(s,'handle background color', nhandleb);

fhandle.color:=tini.ReadInteger(s,'handle color', fHandle.Color);
fhandle.name:=tini.ReadString (s,'handle font name',fHandle.Name);
fhandle.height:=tini.ReadInteger(s, 'handle font height', fHandle.Height);
fhandle.size:=tini.Readinteger(s, 'handle font size', fHandle.Size);

    cTmp := tini.ReadString('Handle', 'Font pitch', 'Default');
    IF (CompareStr(cTmp, 'Variable') = 0) THEN
        fHandle.Pitch := fpVariable
    else
    IF (CompareStr(cTmp, 'Fixed') = 0) THEN
        fHandle.Pitch := fpFixed
    else
        fHandle.Pitch := fpDefault;

    fHandle.Style := [];

    IF (tini.ReadBool('Handle', 'Font style bold', FALSE)) THEN
        fHandle.Style := fHandle.Style + [fsBold];

    IF (tini.ReadBool('Handle', 'Font style italic', FALSE)) THEN
        fHandle.Style := fHandle.Style + [fsItalic];

    IF (tini.ReadBool('Handle', 'Font style underline', FALSE)) THEN
        fHandle.Style := fHandle.Style + [fsUnderline];

    IF (tini.ReadBool('Handle', 'Font style strikeout', FALSE)) THEN
        fHandle.Style := fHandle.Style + [fsStrikeOut];


lbbutton1.setfont(fhandle);
lbbutton2.setfont(fhandle);

fclock.color:=tini.ReadInteger(s,'clock color', fclock.Color);
fclock.name:=tini.ReadString (s,'clock font name',fclock.Name);
fclock.height:=tini.ReadInteger(s, 'clock font height', fclock.Height);
fclock.size:=tini.Readinteger(s, 'clock font size', fclock.Size);

    cTmp := tini.ReadString('Clock', 'Font pitch', 'Default');
    IF (CompareStr(cTmp, 'Variable') = 0) THEN
        fClock.Pitch := fpVariable
    else
    IF (CompareStr(cTmp, 'Fixed') = 0) THEN
        fClock.Pitch := fpFixed
    else
        fClock.Pitch := fpDefault;

    fClock.Style := [];

    IF (tini.ReadBool('Clock', 'Font style bold', FALSE)) THEN
        fClock.Style := fClock.Style + [fsBold];

    IF (tini.ReadBool('Clock', 'Font style italic', FALSE)) THEN
        fClock.Style := fClock.Style + [fsItalic];

    IF (tini.ReadBool('Clock', 'Font style underline', FALSE)) THEN
        fClock.Style := fClock.Style + [fsUnderline];

    IF (tini.ReadBool('Clock', 'Font style strikeout', FALSE)) THEN
        fClock.Style := fClock.Style + [fsStrikeOut];


lbbutton3.setfont(fclock);
lbbutton4.setfont(fclock);

usebmpsquare:=tini.Readbool(s,'use bmp board', usebmpsquare);
usebmppiece:=tini.Readbool(s,'use bmp pieces', usebmppiece);
usebmpbg:=tini.Readbool(s,'use bmp bground', usebmpbg);

bmpsquare:=tini.ReadString(s,'path to board',bmpsquare);
bmppiece:=tini.Readstring(s,'path to pieces',bmppiece);
bmpbg:=tini.Readstring(s,'path to bground', bmpbg);

if pos(':',bmpbg)<1 then bmpbg:=defbgdir+bmpbg;
if pos(':',bmpsquare)<1 then bmpsquare:=defboarddir+bmpsquare;
if pos(':', bmppiece)<1 then bmppiece:=defpiecedir+bmppiece;

initpiecelist;
initboardlist;
initbglist;
if usebmppiece then usebmppiece:=readpieces(tmppieces,bmppiece);
if usebmpsquare then usebmpsquare:=readboard(tmpboard,bmpsquare);
try
 tmpbg.loadfromfile(bmpbg);
except
 usebmpbg:=false;
end;
loadpiece;
paintbox1.invalidate;
paintbox6.invalidate;
 finally
  tini.free;
 end;
end;




procedure tboardcfg.adjustboards;
VAR
    nCW, nCH, nSW, nSH, nW, nH, nL, nT, nBlockH, nZZ: Integer;
BEGIN
    { Adjust paint boxes }
    nCW := paintbox6.Width - 1 - 1;

    IF (lbbutton1.Height > lbbutton3.Height) THEN
    BEGIN
        nBlockH := lbbutton1.Height + 1 + 1 + lbbutton2.Height + HEIGHT_GAP + SpeedButton1.Height;
        nZZ := lbbutton1.Height + 1;
    END
    ELSE
    BEGIN
        nBlockH := lbbutton3.Height + 1 + 1 + lbbutton4.Height + HEIGHT_GAP + SpeedButton1.Height;
        nZZ := lbbutton3.Height + 1;
    END;

    nCH := paintbox6.height - nBlockH;

    nSW := nCW DIV 10;
    nSH := nCH SHR 3;

    IF (nSW > nSH) THEN
    BEGIN
        nW := nSH * 10;
        nH := nSH SHL 3;

        nPieceSize := nSH;
    END
    ELSE
    BEGIN
        nW := nSW * 10;
        nH := nSW SHL 3;

        nPieceSize := nSW;
    END;
    nCH := nPieceSize SHL 3;

        nL := (paintbox6.Width - nCW) SHR 1;
        nT := ((paintbox6.height - nBlockH - nH) SHR 1) + nZZ;

    PaintBox1.SetBounds(paintbox6.left+nL, paintbox6.top+nT, nW, nH);
    nPieceRatio := nPieceSize / 48;
    LoadPiece;

    nboard8:=nh;

END;

PROCEDURE TBoardcfg.AdjustOutlines;
BEGIN
    PaintBox2.SetBounds(PaintBox1.Left  - 1,
                        PaintBox1.Top   - 1,
                        PaintBox1.Width + 2,
                        1);

    PaintBox3.SetBounds(PaintBox1.Left + PaintBox1.Width,
                        PaintBox1.Top - 1,
                        1,
                        PaintBox1.Height + 3);

    PaintBox4.SetBounds(PaintBox2.Left,
                        PaintBox1.Top + PaintBox1.Height,
                        PaintBox2.Width,
                        1);

    PaintBox5.SetBounds(PaintBox1.Left - 1,
                        PaintBox1.Top - 1,
                        1,
                        PaintBox1.Height + 3);
END;

PROCEDURE TBoardcfg.AdjustClocks;
BEGIN
    Lbbutton3.Left := PaintBox1.Left + nBoard8 - Lbbutton3.Width;
    Lbbutton3.Top  := PaintBox1.Top  - Lbbutton3.Height - 1;

    Lbbutton4.Left := PaintBox1.Left + nBoard8 - Lbbutton4.Width;
    Lbbutton4.Top  := PaintBox1.Top  + nBoard8 + 1;
END;

PROCEDURE TBoardcfg.AdjustHandles;
BEGIN
    lbbutton1.Left := PaintBox1.Left + ((nBoard8 - lbbutton1.Width) SHR 1);
    lbbutton1.Top  := PaintBox1.Top  - lbbutton1.Height - 1;

    IF ((lbbutton1.Left + lbbutton1.Width) >= lbbutton3.Left) THEN
        lbbutton1.Left := lbbutton1.Left - ((lbbutton1.Left + lbbutton1.Width) - lbbutton3.Left) - WIDTH_GAP;

    lbbutton2.Left := PaintBox1.Left + ((nBoard8 - lbbutton2.Width) SHR 1);
    lbbutton2.Top  := PaintBox1.Top  + nBoard8 + 1;

    IF ((lbbutton2.Left + lbbutton2.Width) >= lbbutton4.Left) THEN
        lbbutton2.Left := lbbutton2.Left - ((lbbutton2.Left + lbbutton2.Width) - lbbutton4.Left) - WIDTH_GAP;
END;

PROCEDURE TBoardcfg.AdjustSpeeds;
BEGIN
    SpeedButton1.Left := PaintBox1.Left + ((nBoard8 - nSpeedW) SHR 1);
    SpeedButton1.Top  := Lbbutton2.Top + Lbbutton2.Height + HEIGHT_GAP;

    SpeedButton2.Left := SpeedButton1.Left + SpeedButton1.Width;
    SpeedButton2.Top  := SpeedButton1.Top;

    SpeedButton3.Left := SpeedButton2.Left + SpeedButton2.Width;
    SpeedButton3.Top  := SpeedButton1.Top;

    SpeedButton4.Left := SpeedButton3.Left + SpeedButton3.Width;
    SpeedButton4.Top  := SpeedButton1.Top;
END;

procedure tboardcfg.adjustall;
BEGIN
        AdjustBoards;
        AdjustOutlines;
        AdjustClocks;
        AdjustHandles;
        AdjustSpeeds;
END;




FUNCTION GetIndex(cPc: Char): Integer;
BEGIN
    CASE (cPc) OF
        WHITE_PAWN:   Result := PAWN_INDEX;
        WHITE_ROOK:   Result := ROOK_INDEX;
        WHITE_KNIGHT: Result := KNIGHT_INDEX;
        WHITE_BISHOP: Result := BISHOP_INDEX;
        WHITE_QUEEN:  Result := QUEEN_INDEX;
        WHITE_KING:   Result := KING_INDEX;

        BLACK_PAWN:   Result := PAWN_INDEX;
        BLACK_ROOK:   Result := ROOK_INDEX;
        BLACK_KNIGHT: Result := KNIGHT_INDEX;
        BLACK_BISHOP: Result := BISHOP_INDEX;
        BLACK_QUEEN:  Result := QUEEN_INDEX;
        BLACK_KING:   Result := KING_INDEX;

        EMPTY_SQUARE: Result := EMPTY_INDEX;
    ELSE
        Result := UNKNOWN_INDEX;
    END;
END;

FUNCTION GetColor(cPc: Char): Integer;
BEGIN
    CASE (cPc) OF
        WHITE_PAWN:   Result := WHITE_COLOR;
        WHITE_ROOK:   Result := WHITE_COLOR;
        WHITE_KNIGHT: Result := WHITE_COLOR;
        WHITE_BISHOP: Result := WHITE_COLOR;
        WHITE_QUEEN:  Result := WHITE_COLOR;
        WHITE_KING:   Result := WHITE_COLOR;

        BLACK_PAWN:   Result := BLACK_COLOR;
        BLACK_ROOK:   Result := BLACK_COLOR;
        BLACK_KNIGHT: Result := BLACK_COLOR;
        BLACK_BISHOP: Result := BLACK_COLOR;
        BLACK_QUEEN:  Result := BLACK_COLOR;
        BLACK_KING:   Result := BLACK_COLOR;

        EMPTY_SQUARE: Result := EMPTY_COLOR;
    ELSE
        Result := UNKNOWN_COLOR;
    END;
END;

PROCEDURE  tboardcfg.drawsquare(TC:Tcanvas;cl:Tcolor);
BEGIN
   TC.Pen.Color := cl;

    TC.Brush.Color := cl;
    TC.Brush.Style := bsSolid;
    TC.Polygon([ Point(             0,              0),
                 Point(nPieceSize - 1,              0),
                 Point(nPieceSize - 1, nPieceSize - 1),
                 Point(             0, nPieceSize - 1),
                 Point(             0,              0) ]);
END;


procedure Tboardcfg.FormCreate(Sender: TObject);
var i,j,k:integer;
begin
    bOk:=false;
    kchanged:=false;
    npieceSize  := PIECE_ORG_SIZE;
    nPieceRatio := 1;

    defpiecedir:=graphhome+relativepiecedir;
    defboarddir:=graphhome+relativeboarddir;
    defthemedir:=graphhome+relativethemedir;
    defbgdir:=graphhome+relativebgdir;
    customthemedir:=defthemedir;


    nWhtFill     := INI1.INI.nWhtFill;
    nWhtOutline  := INI1.INI.nWhtOutline;
    nWhtSquare   := INI1.INI.nWhtSquare;
    nWhtSOutline := INI1.INI.nWhtSOutline;

    nBlkFill     := INI1.INI.nBlkFill;
    nBlkOutline  := INI1.INI.nBlkOutline;
    nBlkSquare   := INI1.INI.nBlkSquare;
    nBlkSOutline := INI1.INI.nBlkSOutline;

    bOutlinePC   := INI1.INI.bOutlinePC;
    nClickColor  := INI1.INI.nClickColor;


    fclock:=tfont.create;
    fhandle:=tfont.create;


    FOR I := 0 TO 2 DO
    BEGIN
        aNum2PX[I] := Trunc(aNum2X[I] * nPieceRatio);
        aNum2PY[I] := Trunc(aNum2Y[I] * nPieceRatio);
    END;

    for i:=1 to 8 do
    for j:=1 to 8 do
    begin
     k:=j+i-1;
     if odd(k) then asqrclr[i,j]:=BLACK_COLOR
     else asqrclr[i,j]:=WHITE_COLOR;
     aboard[i,j]:=EMPTY_SQUARE;
    end;
    for i:=1 to 8 do aboard[i,2]:=WHITE_PAWN;
    for i:=1 to 8 do aboard[i,7]:=BLACK_PAWN;
    aboard[1,1]:=WHITE_ROOK;
    aboard[2,1]:=WHITE_KNIGHT;
    aboard[3,1]:=WHITE_BISHOP;
    aboard[4,1]:=WHITE_queen;
    aboard[5,1]:=WHITE_king;
    aboard[6,1]:=WHITE_BISHOP;
    aboard[7,1]:=WHITE_knight;
    aboard[8,1]:=WHITE_rook;

    aboard[1,8]:=black_ROOK;
    aboard[2,8]:=black_KNIGHT;
    aboard[3,8]:=black_BISHOP;
    aboard[4,8]:=black_queen;
    aboard[5,8]:=black_king;
    aboard[6,8]:=black_BISHOP;
    aboard[7,8]:=black_knight;
    aboard[8,8]:=black_rook;

   for i:=1 to 2 do for j:=1 to 8 do acpiece[i,j]:=empty_square;
   acpiece[1,1]:=White_pawn;
   acpiece[1,2]:=White_knight;
   acpiece[1,3]:=White_bishop;
   acpiece[1,4]:=White_rook;
   acpiece[1,5]:=White_queen;
   acpiece[2,1]:=Black_pawn;
   acpiece[2,2]:=black_knight;
   acpiece[2,3]:=black_bishop;
   acpiece[2,4]:=black_rook;
   acpiece[2,5]:=black_queen;


    FOR i := 1 TO 3 DO
        FOR j := 1 TO 6 DO
            aImage[i, j] := TBitmap.Create;



    aSquare[1]        := TBitmap.Create;
    aSquare[2]        := TBitmap.Create;
    asquare[3]:=TbitMap.create;

    bTmp              := TBitmap.Create;
    bTmp.Width        := nPieceSize;
    bTmp.Height       := nPieceSize;

    createboard(tmpboard);
    createpieces(tmppieces);
    tmpbg:=tbitmap.create;

    usebmpbg:=usebitmap;
    usebmppiece:=usepiecebitmap;
    usebmpsquare:=useboardbitmap;
    usebmptheme:=ini1.INI.btheme;

    bmpbg:=bg_file;
    bmppiece:=piece_dir;
    bmpsquare:=board_dir;
    bmptheme:=ini1.ini.stheme;

    if usebmppiece then usebmppiece:=readpieces(tmppieces,bmppiece);
    if usebmpbg then  tmpbg.loadfromfile(bmpbg);
    if usebmpsquare then usebmpsquare:=readboard(tmpboard,bmpsquare);

    initpiecelist;
    initbglist;
    initboardlist;
    initthemelist;
    listbox1.itemindex:=0;
end;


PROCEDURE TBoardcfg.LoadPiece;
VAR
    i,j,  nC, nI: Integer;
BEGIN
    { Setup piece rectangle }
    rSqrRect := Rect(0, 0, nPieceSize, nPieceSize);
    { Setup piece image size }
    FOR nC := 1 TO 3 DO
        FOR nI := 1 TO 6 DO
        BEGIN
           aImage[nC, nI].Width  := nPieceSize;
           aImage[nC, nI].Height := nPieceSize;
           if (usebmppiece and (nc<3) )then with aimage[nc,ni] do
           begin
            tmppieces[nc,ni].transparent:=false;
            canvas.stretchdraw(rsqrrect,tmppieces[nc,ni]);
            transparentcolor:=canvas.Pixels[1,1];
            transparent:=true;
           end;
        END;

    { Setup square and temporary image size }
    aSquare[1].Width  := nPieceSize;
    aSquare[1].Height := nPieceSize;

    aSquare[2].Width  := nPieceSize;
    aSquare[2].Height := nPieceSize;

    aSquare[3].Width  := nPieceSize;
    aSquare[3].Height := nPieceSize;

    bTmp.Width        := nPieceSize;
    bTmp.Height       := nPieceSize;
    if usebmppiece then
begin
end
else begin
    DrawWhitePawn  (aImage[1, 1].Canvas,npiecesize,1);
    DrawWhiteRook  (aImage[1, 2].Canvas,npiecesize,1);
    DrawWhiteKnight(aImage[1, 3].Canvas,npiecesize,1);
    DrawWhiteBishop(aImage[1, 4].Canvas,npiecesize,1);
    DrawWhiteQueen (aImage[1, 5].Canvas,npiecesize,1);
    DrawWhiteKing  (aImage[1, 6].Canvas,npiecesize,1);

    DrawBlackPawn  (aImage[2, 1].Canvas,npiecesize,1);
    DrawBlackRook  (aImage[2, 2].Canvas,npiecesize,1);
    DrawBlackKnight(aImage[2, 3].Canvas,npiecesize,1);
    DrawBlackBishop(aImage[2, 4].Canvas,npiecesize,1);
    DrawBlackQueen (aImage[2, 5].Canvas,npiecesize,1);
    DrawBlackKing  (aImage[2, 6].Canvas,npiecesize,1);

    { Setup piece masks }
    DrawPawnMask   (aImage[3, 1].Canvas,npiecesize,1);
    DrawRookMask   (aImage[3, 2].Canvas,npiecesize,1);
    DrawKnightMask (aImage[3, 3].Canvas,npiecesize,1);
    DrawBishopMask (aImage[3, 4].Canvas,npiecesize,1);
    DrawQueenMask  (aImage[3, 5].Canvas,npiecesize,1);
    DrawKingMask   (aImage[3, 6].Canvas,npiecesize,1);
end;
    { Setup empty board squares }
    if usebmpsquare then
    begin
     asquare[1].canvas.stretchdraw(rsqrrect,tmpboard[1]);
     asquare[2].canvas.stretchdraw(rsqrrect,tmpboard[2]);
    end
    else begin
     DrawSquare(aSquare[1].Canvas,nwhtsquare);
     DrawSquare(aSquare[2].Canvas,nblksquare);
    end;
    asquare[3].canvas.copymode:=cmSrcCopy;
    if usebmpbg then
    asquare[3].canvas.stretchdraw(rsqrrect,tmpbg)
    else DrawSquare(aSquare[3].Canvas,npcsquare) ;

         { Second digit number positions }
    FOR nI := 0 TO 2 DO
    BEGIN
        aNum2PX[nI] := Trunc(aNum2X[nI] * nPieceRatio);
        aNum2PY[nI] := Trunc(aNum2Y[nI] * nPieceRatio);
    END;
END;


procedure TboardCfg.Initpiecelist;
var
sr:Tsearchrec;
Att: Integer;
i:integer;
defdir,s:string;
begin
with listbox2 do
begin
 Clear;
 items.add('<Toups>');
 att:=faDirectory;
 defdir:=defpiecedir;
 if findfirst(defdir+'*',att,sr)=0
 then begin
  if validpiecedir(sr.name) then
  begin
   items.add(nicelist(items.count,sr.name));
  end;
  while findnext(sr)=0 do
  if validpiecedir(defdir+sr.name) then
  begin
    items.add(nicelist(items.count,sr.name));
  end;
 end;
 items.add('<Custom>');
 findclose(sr);
 if not usebmppiece then ItemIndex:=0
 else itemindex:=items.count-1;
 for i:=1 to items.count-2 do
 if lowercase(bmppiece)=lowercase(defdir+getpt(Items[i])+DIR_SEP) then itemindex:=i;
 if itemindex=(items.count-1) then
 custompiecedir:=extractfilepath(bmppiece)
 else custompiecedir:=defdir;
end;
end;

procedure TboardCfg.Initboardlist;
var
sr:Tsearchrec;
Att: Integer;
i:integer;
defdir,s:string;
begin
 with listbox3 do
 begin
  Clear;
  items.add('<Solid Color>');
  att:=faDirectory;
  defdir:=defboarddir;
  if findfirst(defdir+'*',att,sr)=0
  then begin
   if validboarddir(defdir+sr.name) then
   begin
    items.add(nicelist(items.count,sr.name));
   end;
   while findnext(sr)=0 do
   if validboarddir(defdir+sr.name) then
   begin
    items.add(nicelist(items.count,sr.name));
   end;
  end;
  items.add('<Custom>');
  findclose(sr);
  if not usebmpsquare then ItemIndex:=0
  else itemindex:=items.count-1 ;
  for i:=1 to items.count-2 do
  if lowercase(bmpsquare)=lowercase(defdir+getpt(listbox3.Items[i]+DIR_SEP)) then listbox3.itemindex:=i;
  if itemindex=(items.count-1) then
  customboarddir:=Extractfilepath(bmpsquare)
  else customboarddir:=defdir;
 end;
end;

procedure TboardCfg.Initbglist;
var
sr:Tsearchrec;
Att: Integer;
i:integer;
defdir,s:string;
begin
 with listbox4 do
 begin
  Clear;
  items.add('<Solid Color>');
  att:=faAnyFile;
  defdir:=defbgdir;
  if findfirst(defdir+'*.bmp',att,sr)=0
  then begin
   items.add(nicelist(items.count,sr.name));
   while findnext(sr)=0 do
   items.add(nicelist(items.count,sr.name));
  end;
  items.add('<Custom>');
  findclose(sr);
  if not usebmpbg then ItemIndex:=0
  else itemindex:=items.count-1 ;
  for i:=1 to items.count-2 do
  if (lowercase(bmpbg)=lowercase(defdir+getpt(Items[i]+'.bmp'))) then itemindex:=i;
  if itemindex>(items.count-2) then
  custombgdir:=extractfilepath(bmpbg)
  else custombgdir:=defdir;
 end;
end;


procedure TboardCfg.Initthemelist;
var
sr:Tsearchrec;
Att: Integer;
i:integer;
defdir,s:string;
begin
 with listbox5 do
 begin
  Clear;
  items.add('<None>');
  att:=faAnyFile;
  defdir:=defthemedir;
  if findfirst(defdir+'*.txt',att,sr)=0
  then begin
   items.add(nicelist(items.count,sr.name));
   while findnext(sr)=0 do
   items.add(nicelist(items.count,sr.name));
  end;
  items.add('<Custom>');
  findclose(sr);
  itemindex:=0;
 end;
end;



PROCEDURE TBoardcfg.DisplayBoard;
BEGIN
    paintbox2.Canvas.Pen.Color:=nboardoutline;
    paintbox3.canvas.pen.color:=nboardoutline;
    paintbox4.canvas.pen.color:=nboardoutline;
    paintbox5.Canvas.pen.color:=nboardoutline;

    PaintBox2.Canvas.MoveTo(0, 0);
    PaintBox2.Canvas.LineTo(PaintBox2.Width - 1, 0);

    PaintBox3.Canvas.MoveTo(0, 0);
    PaintBox3.Canvas.LineTo(0, PaintBox3.Height - 1);

    PaintBox4.Canvas.MoveTo(0, 0);
    PaintBox4.Canvas.LineTo(PaintBox4.Width - 1, 0);

    PaintBox5.Canvas.MoveTo(0, 0);
    PaintBox5.Canvas.LineTo(0, PaintBox5.Height - 1);

    Lbbutton4.Font.Color := nTurnf;
    lbbutton4.Color      := nTurnB;
    lbbutton3.Font.Color := nWaitF;
    lbbutton3.Color      := nWaitB;

    DrawBoard(paintbox1.canvas);
END;

procedure Tboardcfg.drawboard(CV:Tcanvas);
var
    nPX, nPY, nBX, nBY: Integer;
BEGIN
    { Draw top drop pieces }
    DrawDropPc(CV,  9, 1);
    DrawDropPc(CV,  9, 2);
    DrawDropPc(CV,  9, 3);
    DrawDropPc(CV,  9, 4);
    DrawDropPc(CV,  9, 5);
    DrawDropPc(CV, 10, 1);
    DrawDropPc(CV, 10, 2);

    { Draw board }
    FOR nBY := 1 TO 8 DO
        FOR nBX := 1 TO 8 DO
            DrawPiece(CV, nBX, nBY);

    { Draw bottom drop pieces }
    DrawDropPc(CV,  9, 6);
    DrawDropPc(CV,  9, 7);
    DrawDropPc(CV,  9, 8);
    DrawDropPc(CV, 10, 3);
    DrawDropPc(CV, 10, 4);
    DrawDropPc(CV, 10, 5);
    DrawDropPc(CV, 10, 6);
    DrawDropPc(CV, 10, 7);
    DrawDropPc(CV, 10, 8);
END;

PROCEDURE TBoardcfg.DrawPiece(CV: TCanvas; nBX, nBY: Integer);
VAR
    nPX, nPY: Integer;
BEGIN
    nPX := PieceXY(nBX);
    nPY := PieceXY(9-nby);
    DrawPXY(CV, aSqrClr[nBX, nBY], nPX, nPY, aBoard[nBX, nBY]);
END;


PROCEDURE TBoardcfg.DrawPXY(CV: TCanvas; nSc, nPX, nPY: Integer; cPiece: Char);
VAR
    nI: Integer;
BEGIN
    { Copy }
    bTmp.Canvas.CopyMode := cmSrcCopy;
    bTmp.Canvas.CopyRect(rSqrRect, aSquare[nSc].Canvas, rSqrRect);

    IF (cpiece=EMPTY_SQuare) THEN
    BEGIN
        { Nothing }
    END
    ELSE
    BEGIN
        nI := GetIndex(cPiece);

        { And }
       if usebmppiece then
        btmp.canvas.draw(0,0,aimage[GetColor(cPiece),ni])
       else begin
        bTmp.Canvas.CopyMode := cmSrcAnd;
        bTmp.Canvas.CopyRect(rSqrRect, aImage[3, nI].Canvas, rSqrRect);

        { Or }
        bTmp.Canvas.CopyMode := cmSrcPaint;
        bTmp.Canvas.CopyRect(rSqrRect,
                             aImage[GetColor(cPiece), nI].Canvas,
                             rSqrRect);
       end;

       // begin btmp.Canvas.copymode:=cmSrc.
    //   btmp.canvas.draw(0,0,aimage[Chess.GetColor(cPiece),ni])
    END;


    { Copy }
    CV.CopyRect(Rect(nPX, nPY, nPX + nPieceSize, nPY + nPieceSize),
                bTmp.Canvas, rSqrRect);
END;



procedure Tboardcfg.bgpaint;
var x,y:integer;
BEGIN
 with paintbox6 do
 begin
 y := 0;
  while y < Height do
  begin
    x := 0;
    while x < Width do
    begin
      Canvas.Draw(x, y, tmpbg);
      x := x + tmpbg.Width;
    end;
    y := y + tmpbg.Height;
  end;
 end;
end;

procedure Tboardcfg.PaintBox6Paint(Sender: TObject);
begin
 if usebmpbg then bgpaint
 else with paintbox6.canvas do
 begin
  Pen.Color := paintbox6.Color;
  Brush.Color := paintbox6.color;
  Brush.Style := bsSolid;
  Polygon([ Point(             0,              0),
                 Point(width - 1,              0),
                 Point(width - 1, height - 1),
                 Point(             0, height - 1),
                 Point(             0,              0) ]);
 end;
 displayboard;
end;

FUNCTION TBoardcfg.PieceXY(nI: Integer): Integer;
BEGIN
    Result := ((nI - 1) * nPieceSize);
END;

FUNCTION TBoardcfg.GetDropIndex(nBX, nBY: Integer): Integer;
BEGIN
    CASE (nBY) OF
        1: IF (nBX = 9) THEN Result := 1 ELSE Result := 4;
        2: IF (nBX = 9) THEN Result := 2 ELSE Result := 5;
        3: IF (nBX = 9) THEN Result := 3 ELSE Result := 0;

        6: IF (nBX = 9) THEN Result := 1 ELSE Result := 4;
        7: IF (nBX = 9) THEN Result := 2 ELSE Result := 5;
        8: IF (nBX = 9) THEN Result := 3 ELSE Result := 0;
    ELSE
        Result := 0;
    END;
END;

PROCEDURE TBoardcfg.Draw5(TC: TCanvas);
BEGIN
    TC.Pen.Color := nNumberColor;
    TC.MoveTo(aNum2PX[2], aNum2PY[0]);
    TC.LineTo(aNum2PX[0], aNum2PY[0]);
    TC.LineTo(aNum2PX[0], aNum2PY[1]);
    TC.LineTo(aNum2PX[2], aNum2PY[1]);
    TC.LineTo(aNum2PX[2], aNum2PY[2]);
    TC.LineTo(aNum2PX[0], aNum2PY[2]);
END;

PROCEDURE Tboardcfg.DrawDropPc(CV: TCanvas; nBX, nBY: Integer);
VAR
    nP, nPX, nPY, nC, nI: Integer;
BEGIN
    nPX := PieceXY(nBX);
    nPY := PieceXY(nBY);

    nP := GetDropIndex(nBX, nBY);
    IF (nP = 0) THEN
    BEGIN
        { Copy }
        bTmp.Canvas.CopyMode := cmSrcCopy;
        bTmp.Canvas.CopyRect(rSqrRect, aSquare[3].Canvas, rSqrRect);

        { Copy }
      CV.CopyRect(Rect(nPX, nPY, nPX + nPieceSize, nPY + nPieceSize),
                  bTmp.Canvas, rSqrRect);
        EXIT;
    END;

    IF (nBY < 4) THEN
            nC := Black_Color
        ELSE
            nC := White_Color;
    ni:=getindex(acpiece[nc,np]);
    { Copy }
    bTmp.Canvas.CopyMode := cmSrcCopy;
    bTmp.Canvas.CopyRect(rSqrRect, aSquare[3].Canvas, rSqrRect);

        { And }
        if not usebmppiece then
        begin
         bTmp.Canvas.CopyMode := cmSrcAnd;
         bTmp.Canvas.CopyRect(rSqrRect, aImage[3, nI].Canvas, rSqrRect);

        { Or }
         bTmp.Canvas.CopyMode := cmSrcPaint;
         bTmp.Canvas.CopyRect(rSqrRect, aImage[nC, nI].Canvas, rSqrRect);
        end
        else bTmp.Canvas.draw(0,0, aImage[nC, nI]);

        { Draw # of pieces remaining }
        Draw5(bTmp.Canvas);

    { Copy }
   CV.CopyRect(Rect(nPX, nPY, nPX + nPieceSize, nPY + nPieceSize),
               bTmp.Canvas, rSqrRect);
END;

Destructor Tboardcfg.Destroy;
var nc,ni:integer;
begin
  FOR nC := 1 TO 3 DO
  FOR nI := 1 TO 6 DO

  aImage[nC, nI].Free;

  FOR nC := 1 TO 3 DO
  aSquare[nC].Free;


  bTmp.Free;
  freepieces(tmppieces);
  freeboard(tmpboard);
  tmpbg.free;
  fclock.free;
  fhandle.free;
  inherited;
end;

procedure Tboardcfg.Button2Click(Sender: TObject);
begin
 close;
end;

procedure tboardcfg.savechanges;
begin
bOk:=true;
end;

procedure Tboardcfg.Button1Click(Sender: TObject);
begin
 savechanges;
 close;
end;

procedure Tboardcfg.ListBox2Click(Sender: TObject);
var I,ps:integer;
s:string;
begin
 with sender as tlistbox do
 begin
 ps:=pos('x',name);
 s:=copy(name,ps+1,length(name));
 val(s,i,ps);
  case I of
 2: changeset(listbox2.ItemIndex);
 3: changeboard(listbox3.itemindex);
 4: changebg(listbox4.itemindex);
 5: changetheme(listbox5.itemindex);
  end;
 end;
end;

procedure Tboardcfg.ListBox2KeyDown(Sender: TObject; var Key: Word;Shift:Tshiftstate);
var i,ps:integer;
s:string;
begin
 if (Key=VK_UP) or (Key=VK_DowN) then
 with sender as tlistbox do
 begin
 if not kchanged then exit;
 ps:=pos('x',name);
 s:=copy(name,ps+1,length(name));
 val(s,i,ps);
  case I of
 2: changeset(listbox2.ItemIndex);
 3: changeboard(listbox3.itemindex);
 4: changebg(listbox4.itemindex);
 5: changetheme(listbox5.itemindex);
  end;
 end;

end;

procedure Tboardcfg.ListBox2Enter(Sender: TObject);
begin
 kchanged:=false;
end;

procedure Tboardcfg.ListBox1Click(Sender: TObject);
var i:integer;
begin
 with Sender as tlistbox do i:=itemindex;
 case i of
 0: chwsqcol;
 1: chbsqcol;
 2: chbbgcol;
 3: chpolcol;
 4: chbolcol;
 5: chbdscol;
 6: chcfont;
 7: chcwfcol;
 8: chcwbcol;
 9: chctfcol;
 10:chctbcol;
 11:chhfont;
 12:chhbgcol;
 end;
end;



procedure Tboardcfg.Button4Click(Sender: TObject);
begin
 listbox1click(listbox1);
end;

procedure Tboardcfg.Button5Click(Sender: TObject);
var
tini:Tinifile;
s,sname:string;
begin
 save1.initialdir:=defthemedir;
 save1.Title:='Save current configuration as...';
 if save1.execute then
 try
  s:='Board';
  tini:=Tinifile.create(save1.filename);
  tini.WriteInteger(s,'white square color',nwhtsquare);
  tini.WriteInteger(s,'black square color', nblksquare);
  tini.WriteInteger(s,'piece count color', nnumbercolor);
  tini.WriteInteger(s,'board background color', paintbox6.color);
tini.WriteInteger(s,'board outline color', nboardoutline);
tini.WriteInteger(s,'Drop Space Color', npcsquare);
tini.WriteInteger(s,'clock wait foreground color', nwaitf);
tini.WriteInteger(s,'clock wait background color', nwaitb);
tini.WriteInteger(s,'clock turn foreground color', nturnf);
tini.WriteInteger(s,'clock turn background color', nturnb);
tini.WriteInteger(s,'handle background color', nhandleb);

tini.WriteInteger(s,'handle color', fHandle.Color);
tini.writeString (s,'handle font name',fHandle.Name);
tini.writeInteger(s, 'handle font height', fHandle.Height);
tini.writeinteger(s, 'handle font size', fHandle.Size);

    CASE (fHandle.Pitch) OF
        fpVariable: tini.WriteString('Handle', 'Font pitch', 'Variable');
        fpFixed:    tini.WriteString('Handle', 'Font pitch', 'Fixed');
    ELSE
        tini.WriteString('Handle', 'Font pitch', 'Default');
    END;

    tini.WriteBool('Handle', 'Font style bold',      (fsBold      IN fHandle.Style));
    tini.WriteBool('Handle', 'Font style italic',    (fsItalic    IN fHandle.Style));
    tini.WriteBool('Handle', 'Font style underline', (fsUnderline IN fHandle.Style));
    tini.WriteBool('Handle', 'Font style strikeout', (fsStrikeOut IN fHandle.Style));


tini.WriteInteger(s,'clock color', fclock.Color);
tini.writeString (s,'clock font name',fclock.Name);
tini.writeInteger(s, 'clock font height', fclock.Height);
tini.writeinteger(s, 'clock font size', fclock.Size);
    CASE (fClock.Pitch) OF
        fpVariable: tini.WriteString('Clock', 'Font pitch', 'Variable');
        fpFixed:    tini.WriteString('Clock', 'Font pitch', 'Fixed');
    ELSE
        tini.WriteString('Clock', 'Font pitch', 'Default');
    END;

    tini.WriteBool('Clock', 'Font style bold',      (fsBold      IN fClock.Style));
    tini.WriteBool('Clock', 'Font style italic',    (fsItalic    IN fClock.Style));
    tini.WriteBool('Clock', 'Font style underline', (fsUnderline IN fClock.Style));
    tini.WriteBool('Clock', 'Font style strikeout', (fsStrikeOut IN fClock.Style));



  tini.writebool(s,'use bmp board', usebmpsquare);
  tini.writebool(s,'use bmp pieces', usebmppiece);
  tini.writebool(s,'use bmp bground', usebmpbg);

with listbox2 do
if usebmppiece then
 if itemindex<(items.count-1) then
 tini.writestring(s, 'path to pieces', getpt(items[itemindex]+DIR_SEP))
 else tini.writestring(s, 'path to pieces', bmppiece);

with listbox3 do
if usebmpsquare then
 if itemindex<(items.count-1) then
 tini.writestring(s, 'path to board', getpt(items[itemindex]+DIR_SEP))
 else tini.writestring(s, 'path to board', bmpsquare);

with listbox4 do
if usebmpbg then
 if itemindex<(items.count-1) then
 tini.writestring(s, 'path to bground', getpt(items[itemindex])+'.bmp')
 else tini.writestring(s, 'path to bground', bmpbg);
 finally
  tini.free;
 end;
 initthemelist;
end;

procedure Tboardcfg.FormShow(Sender: TObject);
begin
 lbbutton1.color:=nhandleb;
 lbbutton2.color:=nhandleb;
 lbbutton1.setfont(fhandle);
 lbbutton2.setfont(fhandle);
 lbbutton3.setfont(fclock);
 lbbutton4.setfont(fclock);
 lbbutton3.color:=nwaitb;
 lbbutton4.color:=nturnb;
 lbbutton3.Font.color:=nwaitf;
 lbbutton4.font.color:=nturnf;
 adjustall;
end;

procedure Tboardcfg.Button3Click(Sender: TObject);
begin
    nWhtSquare   := DEFnwhtsquare;
    nBlkSquare   := defnBlkSquare;
    nNumberColor := defnNumbercolor;
    nPcSquare    := defnPcSquare;
    nboardoutline:=defnboardoutline;
    PaintBox6.color:=defBgColor;


    nWaitf:=defnwaitf;
    nwaitb:=defnWaitb;
    nturnb:=defnturnb;
    nturnf:=defnturnf;

    nHandleB:=defnHandleB;

    fClock.Color  := deffclock_color;
    fClock.Height := deffclock_height;
    fClock.Name   := deffclock_name;
    fClock.Pitch  := deffclock_pitch;
    fClock.Size   := deffclock_size;
    fClock.Style  := [];

    fHandle.Color  := deffhandle_color;
    fHandle.Height := deffhandle_height;
    fHandle.Name   := deffhandle_name;
    fHandle.Pitch  := deffhandle_pitch;
    fHandle.Size   := deffhandle_size;
    fHandle.Style  := [];

    lbbutton1.font:=fhandle;
    lbbutton2.font:=fhandle;
    lbbutton3.font:=fclock;
    lbbutton4.font:=fclock;
    lbbutton3.font.color:=nwaitf;
    lbbutton4.font.color:=nwaitb;

    usebmppiece:=defusepiecebmp;
    usebmpsquare:=defuseboardbmp;
    usebmpbg:=defusebmp;
    bmppiece:=graphhome+relativepiecedir+defp_dir;
    bmpsquare:=graphhome+relativeboarddir+defb_dir;
    bmpbg:=graphhome+relativebgdir+defbmpfile;

    if usebmppiece then usebmppiece:=readpieces(tmppieces,bmppiece);
    if usebmpsquare then usebmpsquare:=readboard(tmpboard,bmpsquare);
    try
     tmpbg.loadfromfile(bmpbg);
    except
     usebmpbg:=false;
    end;
    loadpiece;
    paintbox1.invalidate;
    paintbox6.invalidate;
end;

end.
