(*============================================================================*)
(* dbdepth.PAS -- BPGN SAVE Depth Form                                        *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2002 Fermy                               *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 2004.12.02 First Construction                                              *)
(*============================================================================*)

unit dbdepth;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  Misc,Global;

type
  TdbDepthForm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure SetupValues(currentSD:integer);
//    procedure ShortGCaptions;
  private
    { Private declarations }
    defaultValue:integer;
  public
    { Public declarations }
    bOk:boolean;
    savedepthvalue:integer;
  end;


implementation

{$R *.dfm}
procedure tdbdepthForm.SetupValues(currentsd:integer);
var s:string;
begin
 bOk:=false;
 savedepthvalue:=currentsd;
 str(savedepthvalue,s);
 edit1.Text:=s;
 defaultValue:=Default_DB_Save_depth;
end;

procedure TdbDepthForm.Button1Click(Sender: TObject);
var sdv,err:integer;
begin
 val(edit1.Text,sdv,err);
 if err<>0 then
 begin
  wError('Please enter a whole number');
  ActiveControl:=edit1;
  exit;
 end;
 savedepthvalue:=sdv;
 bOk:=true;
 close;
end;



procedure TdbDepthForm.Button2Click(Sender: TObject);
begin
 bOk:=false;
 close;
end;

procedure TdbDepthForm.Button3Click(Sender: TObject);
begin
 bOk:=true;
 savedepthvalue:=defaultValue;
 close;
end;

{procedure TdbDepthForm.ShortGCaptions;
begin
 Caption:='Kill short games';
 label1.Caption:='Enter below the maximum number of moves that a short game may contain'+EOL_STR+
 'Note: if this value is bigger than the Database depth at the time of creation of current database, the results will be wrong';
 DefaultValue:=Default_sh_game_max;
end;}


end.
