(*============================================================================*)
(* engann.PAS -- Engine Annotation form                                       *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2002 Fermy                               *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 2002.01.16: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)

unit engann;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  misc, Buttons;

type
  TEngAnForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit3: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    BitBtn1: TBitBtn;
    Label9: TLabel;
    Label10: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }

    function validate(var code:integer):boolean;
  public
    bOk:boolean;
    procedure setupvalues(s1,s2,s3:Real;showmates:boolean;name:string);
    { Public declarations }
  end;

implementation

{$R *.DFM}
procedure TEngAnForm.setupvalues(s1,s2,s3:Real;showmates:boolean;name:string);
var s:string;
begin
 Label2.caption:='Annotate this game with '+name+'?';
 str(s1:3:3,s);edit1.text:=s;
 str(s2:3:3,s);edit2.text:=s;
 str(s3:3:3,s);edit3.text:=s;
 checkbox1.checked:=false;
 checkbox2.checked:=showmates;
 checkbox3.checked:=false;
 bOk:=false;
end;

function TEngAnForm.Validate(var code:integer):boolean;
var cd:integer;
res:real;
begin
 val(edit1.text,res,cd);
 if(( cd<>0) or (res<=0)) then
 begin code:=1;Result:=false;exit;end;
 val(edit1.text,res,cd);
 if(( cd<>0) or (res<0)) then
 begin code:=2;Result:=false;exit;end;
 val(edit1.text,res,cd);
 if(( cd<>0) or (res<0)) then
 begin code:=3;Result:=false;exit;end;
 Result:=true;
 code:=0;
end;

procedure TEngAnForm.Button2Click(Sender: TObject);
begin
 bOk:=false;
 close;
end;

procedure TEngAnForm.Button1Click(Sender: TObject);
var code:integer;
begin
 if validate(code) then begin bok:=true;close; end
 else case code of
 1: Begin
     Werror('Time Per Move should be a positive number');
     ActiveControl:=edit1;
    end;
 2: Begin
     Werror('Difference sould be a nonnegative number');
     ActiveControl:=edit2;
    end;
 3: begin
     Werror('All parameters must be nonnegative numbers');
     ActiveControl:=edit3;
    end;
 end;
end;

end.
