(*============================================================================*)
(* engtest.PAS -- Engine Test Form                                            *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2002 Fermy                               *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 2002.01.16: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)

unit engtest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  misc, Buttons;

type
  TEngTestForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    Edit1: TEdit;
    Label8: TLabel;
    BitBtn1: TBitBtn;
    Label9: TLabel;
    Label10: TLabel;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }

    function validate(var code:integer):boolean;
  public
    bOk:boolean;
    procedure setupvalues(s1:Real;name:string);
    { Public declarations }
  end;

implementation

{$R *.DFM}
procedure TEngTestForm.setupvalues(s1:Real;name:string);
var s:string;
begin
 Label2.caption:='Test '+name+'?';
 str(s1:3:3,s);edit1.text:=s;
 bOk:=false;
 checkbox1.checked:=false;
end;

function TEngTestForm.Validate(var code:integer):boolean;
var cd:integer;
res:real;
begin
 val(edit1.text,res,cd);
 if(( cd<>0) or (res<=0)) then
 begin code:=1;Result:=false;exit;end;
 Result:=true;
 code:=0;
end;

procedure TEngTestForm.Button2Click(Sender: TObject);
begin
 bOk:=false;
 close;
end;

procedure TEngTestForm.Button1Click(Sender: TObject);
var code:integer;
begin
 if validate(code) then begin bok:=true;close; end
 else
 Begin
     Werror('Time Per Move should be a positive number');
     ActiveControl:=edit1;
 end;
end;

end.
