(*============================================================================*)
(* merge.PAS -- Merge Bpgns form                                              *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2002 Fermy                               *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 2002.04-05: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)

unit merge;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,FileCtrl,misc;

type
  TMergeForm = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Open1: TOpenDialog;
    Save1: TSaveDialog;
    procedure SetupValues(s:string);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    bOk:boolean;
    { Public declarations }
  end;

var
  MergeForm: TMergeForm;

implementation

{$R *.DFM}
procedure Tmergeform.SetupValues(s:string);
begin
 bOk:=false;
 ActiveControl:=button1;
 Open1.InitialDir:=s;
 Save1.InitialDir:=s;
end;


procedure TMergeForm.Button3Click(Sender: TObject);
var odir:string;
begin
 edit1.text:=trim(edit1.text);
 edit2.text:=trim(edit2.text);
 odir:=ExtractFilePath(edit1.text);
 if ((not DirectoryExists(odir))or (length(odir)<1)) then
 begin Werror('Directory ' + odir+' does not exist.'); ActiveControl:=edit1; exit;end;
 If fileexists(edit2.text) then
  if not wYesNo('Target file ('+edit2.text+') already exists. Overwright?') then
  begin
   activeControl:=edit2; exit;
  end;
 bOk:=true;
 Close;
end;

procedure TMergeForm.Button4Click(Sender: TObject);
begin
 close;
end;

procedure TMergeForm.Button1Click(Sender: TObject);
var dir,ext:string;
begin
 if Open1.Execute then
 begin
  dir:=ExtractFilePath(open1.filename);
  ext:=ExtractFileExt(open1.filename);
  edit1.text:=dir+'*'+ext;
  edit2.text:=dir+'merge'+ext;
  save1.InitialDir:=dir;
 end;
end;

procedure TMergeForm.Button2Click(Sender: TObject);
begin
 if Save1.Execute then
 begin
  edit2.text:=save1.FileName;
 end;
end;

end.
