(*============================================================================*)
(* ProgressDB.PAS -- Progress bar for long operations                         *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2001-2005 Fermy                          *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 2004.11.07: First construction.                                            *)
// 2005.01.10: Added Cancel button and function SetAbort
// 2005.01.29: Added Button1Click
(*----------------------------------------------------------------------------*)
unit progressdb;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls,
  Global;

type
  TProgBar = class(TForm)
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     bAbort:boolean;
     procedure setAbort(bAllowAbort:boolean);
  end;



implementation

{$R *.dfm}




procedure TProgBar.FormCreate(Sender: TObject);
begin
 top:=screen.Height div 3 - height div 3;
 left:=screen.Width div 2 - width div 2;
end;

procedure Tprogbar.setAbort(bAllowAbort:boolean);
begin
 if bAllowAbort then
  width:=button1.Width+button1.Left+progressbar1.Left
 else
  width:=progressbar1.Width+2*progressbar1.Left;
 button1.Visible:=bAllowAbort;
 bAbort:=false;
 FormCreate(Self);
end;



procedure TProgBar.Button1Click(Sender: TObject);
begin
  PostMessage(fMainHandle,WM_Cancel_OP,0,0);
end;

end.
