(*============================================================================*)
(* MAIN.PAS -- Main program                                                   *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2002-2005 Fermy                          *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 2004.12.23: First construction.                                            *)
// 2005.03.01: Fixed checkTime to allow non-integer time
// 2005.03.02: Removed gengame and added genbpgnrec. Game generation moved to
//             bpgn object where it belongs.
(*============================================================================*)
unit setupall;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,
  misc,global,bpgnlist;

type
  Tsetupallform = class(TForm)
    Bevel1: TBevel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Label6: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Label7: TLabel;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Edit13: TEdit;
    Label10: TLabel;
    Edit14: TEdit;
    Label11: TLabel;
    Edit15: TEdit;
    Edit16: TEdit;
    Label13: TLabel;
    Edit17: TEdit;
    Label12: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit18: TEdit;
    Edit19: TEdit;
    Edit20: TEdit;
    Edit21: TEdit;
    Label14: TLabel;
    Bevel2: TBevel;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    CheckBox3: TCheckBox;
    Label2: TLabel;
    Edit22: TEdit;
    Edit23: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    CheckBox2: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    Label19: TLabel;
    RadioGroup1: TRadioGroup;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Edit24: TEdit;
    Edit25: TEdit;
    Label23: TLabel;
    Edit26: TEdit;

    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    function checkvalid:boolean;
    procedure genBPGNrec (P:pbpgnrec);


   private
   cTimeC:string;
    { Private declarations }
  public
    { Public declarations }
  end;
function checkhandle(s:string):boolean;
function checkrating(s:string):boolean;
function checkint(s:string):boolean;
function checktime(s:string):boolean;
function checkdate(s:string):boolean;
function checksquare(s:string):boolean;


implementation

{$R *.dfm}

procedure Tsetupallform.FormCreate(Sender: TObject);
begin
 left:=(screen.Width - width) div 2;
 top:=(screen.Height - height) div 3;
end;


procedure Tsetupallform.Button1Click(Sender: TObject);
begin
 if checkvalid then modalResult:=mrOk;
end;

function tsetupallform.checkvalid:boolean;
var terr,rerr,merr,derr,sqerr:string;
begin
 rerr:='Invalid rating'+EOL_STR+'Valid ratings are integer numbers, empty, ++++ and ----';
 terr:='Invalid time'+EOL_STR+'Time should be in mm:ss format';
 merr:='Invalid first move number'+EOL_STR+'Move # should be an integer';
 derr:='Invalid date'+EOL_STR+'Date format is yy.mm.dd'+EOL_STR+'If date is unknown, use ? or ??.??.??';
 sqerr:='Enpassant square can be on the 3rd or 6th rank only'+EOL_STR+'Square format is standard, e.g. e6';
 {handles}
 if not checkhandle(edit9.Text) then
 begin
  ActiveControl:=edit9;
  wError('Handle cannot be empty');
  result:=false; exit;
 end;

 if not checkhandle(edit10.Text) then
 begin
  ActiveControl:=edit10;
  wError('Handle cannot be empty');
  result:=false; exit;
 end;

 if not checkhandle(edit11.Text) then
 begin
  ActiveControl:=edit11;
  wError('Handle cannot be empty');
  result:=false; exit;
 end;

 if not checkhandle(edit12.Text) then
 begin
  ActiveControl:=edit12;
  wError('Handle cannot be empty');
  result:=false; exit;
 end;

 {ratings}
 if not checkrating(edit18.Text) then
 begin
  ActiveControl:=edit18;
  wError(rerr);
  result:=false; exit;
 end;

 if not checkrating(edit19.Text) then
 begin
  ActiveControl:=edit19;
  wError(rerr);
  result:=false; exit;
 end;

 if not checkrating(edit20.Text) then
 begin
  ActiveControl:=edit20;
  wError(rerr);
  result:=false; exit;
 end;

 if not checkrating(edit21.Text) then
 begin
  ActiveControl:=edit21;
  wError(rerr);
  result:=false; exit;
 end;

 {move #}
 if not checkint(edit22.Text) then
 begin
  ActiveControl:=edit22;
  wError(merr);
  result:=false; exit;
 end;
 if not checkint(edit23.Text) then
 begin
  ActiveControl:=edit23;
  wError(merr);
  result:=false; exit;
 end;

 {times}
 if not checktime(edit5.Text) then
 begin
  ActiveControl:=edit5;
  Werror(terr);
  result:=false;exit;
 end;

 if not checktime(edit6.Text) then
 begin
  ActiveControl:=edit6;
  Werror(terr);
  result:=false;exit;
 end;

 if not checktime(edit7.Text) then
 begin
  ActiveControl:=edit7;
  Werror(terr);
  result:=false;exit;
 end;

 if not checktime(edit8.Text) then
 begin
  ActiveControl:=edit8;
  Werror(terr);
  result:=false;exit;
 end;

 if not checkdate(edit15.Text) then
 begin
  ActiveControl:=edit15;
  wError(derr);
  result:=false; exit;
 end;

 if not checkint(edit16.Text) then
 begin
  ActiveControl:=edit16;
  Werror('Invalid timecontrol time'+EOL_STR+'Time should be an integer');
  result:=false;exit;
 end;

 if not checkint(edit17.Text) then
 begin
  ActiveControl:=edit17;
  Werror('Invalid increment'+EOL_STR+'Increment should be an integer');
  result:=false;exit;
 end;
 cTimeC:=trim(Edit16.Text)+'+'+trim(edit17.Text);

 {enpassant}
 if not checksquare(edit24.Text) then
 begin
  ActiveControl:=edit24;
  Werror(sqerr);
  result:=false;exit;
 end;
 if not checksquare(edit25.Text) then
 begin
  ActiveControl:=edit24;
  Werror(sqerr);
  result:=false;exit;
 end;
 if ((pos('{',edit26.Text)>0) or (pos('}',edit26.Text)>0)) then
 begin
  Activecontrol:=edit26;
  Werror('Symbols { and } are illegal in the result reason');
  result:=false;exit;
 end;

 Result:=true;
end;

function checkhandle(s:string):boolean;
begin
 if length(trim(s))> 0 then Result:=true
 else result:=false;
end;

function checkrating(s:string):boolean;
var res,err:integer;
begin
 s:=trim(s);
 if ((s='----') or (s='') or (s='++++')) then begin Result:=true; exit;end;
 val(s,res,err);
 if err<>0 then Result:=false else result:=true;
end;

function checkint(s:string):boolean;
var res,err:integer;
begin
 val(s,res,err);
 if err=0 then Result:=true else result:=false;
end;

function checkdate(s:string):boolean;
var dt:tdatetime;
er:integer;
begin
  if ((s='?') or (s='??.??.??')) then begin result:=true; exit;end;
  dt:=longstrtodate(s,er);
  if er<0 then result:=false else result:=true;
end;

function checktime(s:string):boolean;
var ps,r1,er:integer;
r2:real;
s1,s2:string;
begin
 s:=trim(s);
 ps:=pos(':',s);
 if ps=0 then begin result:=false; exit;end;

 s1:=copy(s,1,ps-1);
 s2:=copy(s,ps+1,length(s));
 val(s2,r2,er);
 Result:=(checkint(s1) and (er=0))
end;

procedure tsetupallform.genBPGNrec(p:pbpgnrec);
var cResult,cReason:string;
begin
 cresult:=resultbytetostr(radiogroup1.ItemIndex+1);
 cReason:='{'+trim(edit26.Text)+'} ' + cresult;
 with p^ do
   begin
    aTag:=TAG_OK;
    aWhiteA:=trim(Edit9.Text);
    aBlackA:=trim(Edit10.Text);
    aWhiteB:=trim(Edit11.Text);
    aBlackB:=trim(Edit12.Text);
    aEvent:=trim(Edit13.Text);
    aSite:=trim(Edit14.Text);
    adate:=trim(Edit15.text);
    aRWA:=trim(Edit18.text);
    arba:=trim(Edit19.text);
    arwb:=trim(Edit20.text);
    arbb:=trim(Edit21.text);
    aresult:=cresult;
    areason:=creason;
    aTimeC:=cTimeC;
    aSetup:='1';
   end;
end;

function checksquare(s:string):boolean;
var crows,cfiles:string;
begin
 crows:='abcdefgh';
 cfiles:='36';
 s:=trim(s);
 if s='' then begin result:=true;exit;end;
 if ((length(s)=2) and (pos(s[1],crows)>0) and (pos(s[2],cfiles)>0))
 then result:=true
 else result:=false;
end;



end.
