(*============================================================================*)
(* split.PAS -- Split Bpgn into bug and zh form                               *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2002 Fermy                               *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 2002.04-05: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)

unit split;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,misc;

type
  TSplitForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Save1: TSaveDialog;
    procedure SetupValues(s:string);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    bOk:boolean;
    ot1:integer;
    ot2:integer;
  end;

var
  SplitForm: TSplitForm;

implementation

{$R *.DFM}
procedure tsplitform.SetupValues(s:string);
var dir,name:string;
begin
 bOk:=false;
 dir:=ExtractFilePath(s);
 name:=ExtractFileName(s);
 save1.initialdir:=dir;
 Caption:='Split '+s+' into Bug and Zh parts';
 edit1.Text:=dir+'bug'+name;
 edit2.text:=dir+'zh'+name;
end;

procedure TSplitForm.Button1Click(Sender: TObject);
begin
 if save1.execute then edit1.text:=save1.filename;
end;

procedure TSplitForm.Button2Click(Sender: TObject);
begin
 if save1.Execute then edit2.text:=save1.filename;
end;

procedure TSplitForm.Button4Click(Sender: TObject);
begin
 close;
end;

procedure TSplitForm.Button3Click(Sender: TObject);
begin
 edit1.text:=trim(edit1.text);
 edit2.text:=trim(edit2.text);
 ot1:=1;ot2:=1;//overwright files
 if fileexists(edit1.text) then
 begin
  ot1:=wYesNoCancel('File '+edit1.text+' already exists. Overwright?');
  if ot1=3 then
  begin
     activecontrol:=edit1; exit;
  end;
 end;
 if fileexists(edit2.text) then
 begin
  ot2:=wYesNoCancel('File '+edit2.text+' already exists. Overwright?');
  if ot2=3 then
  begin
   activecontrol:=edit2; exit;
  end;
 end;
 bOk:=true;
 close;
end;

end.
