(*============================================================================*)
(* stat.PAS -- Player Stats form                                              *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan, 2002 Fermy                               *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 2002.04-05: First construction.                                            *)
(* 2004.11.06: Modified behavior.                                             *) 
(* If there are no games played, stats shows "-" rather than "0"              *)
(* 2004.12.06 Now Result strings xxx resigned are also counted as resignations*)
(*============================================================================*)

unit stat;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,Bpgnx,Global;

type
PBPGN=^TBPGN;
  TStatsForm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    Label55: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Label58: TLabel;
    Label59: TLabel;
    Label60: TLabel;
    Label61: TLabel;
    Label62: TLabel;
    Label63: TLabel;
    Label64: TLabel;
    Label65: TLabel;
    Label66: TLabel;
    Label67: TLabel;
    Label68: TLabel;
    Label69: TLabel;
    Label70: TLabel;
    Label71: TLabel;
    Label72: TLabel;
    Label73: TLabel;
    Label74: TLabel;
    Label75: TLabel;
    Label76: TLabel;
    Label77: TLabel;
    Label78: TLabel;
    Label79: TLabel;
    Label80: TLabel;
    Label81: TLabel;
    Label82: TLabel;
    Label83: TLabel;
    Label84: TLabel;
    Label85: TLabel;
    Label86: TLabel;
    Label87: TLabel;
    Label88: TLabel;
    Label89: TLabel;
    Label90: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    procedure genstat(pl:string);
    { Private declarations }
  public
    bp:Pbpgn;
    { Public declarations }
  end;


implementation

{$R *.DFM}
const NOTHING='-';

procedure Tstatsform.genstat(pl:string);
var i,n,fc,pls,plres,ops,ps,pops,rat,rat1:integer;
s,player,opponent,pardop,partner:string;
rwin,rloss,rdraw,rtot,uwin,uloss,udraw,utot:integer;
bwin,bloss,bdraw,wwin,wloss,wdraw,wtot,btot:integer;
rmin,rmax,prmin,prmax,ormin,ormax,trmin,trmax,otrmin,otrmax:integer;
srtot,ortot,prtot,otrtot:real;
fwin,floss,mwin,mloss,pwin,ploss,reswin,resloss,restags,othertot,otherwin,otherloss:integer;
tmp:real;

begin
 rwin:=0; rloss:=0; rdraw:=0;rtot:=0;uwin:=0;uloss:=0;udraw:=0;utot:=0;
 bwin:=0;bloss:=0;bdraw:=0;wwin:=0;wloss:=0;wdraw:=0;wtot:=0;btot:=0;
 rmin:=INFTY;rmax:=0;prmin:=INFTY;prmax:=0;ormin:=INFTY;ormax:=0;trmin:=INFTY;trmax:=0;otrmin:=INFTY;otrmax:=0;
 srtot:=0;ortot:=0;prtot:=0;otrtot:=0;
 fwin:=0;floss:=0;mwin:=0;mloss:=0;pwin:=0;ploss:=0;reswin:=0;resloss:=0;
 fc:=bp^.nFilterCount-1;
 for i:=0 to fc do
 begin
  n:=bp^.getfindex(i);
  pls:=bp^.getplayerside(pl,n);
  if pls=0 then continue;

  plres:=bp^.getsideresult(pls,n);
  ops:=bp^.getopponentside(pls);
  ps:=bp^.getpartnerside(pls);
  pops:=bp^.getopponentside(ps);

  if bp^.israted(n) then
  begin
   inc(rtot,1);
   case plres of
   1: inc(rwin,1);
   2: inc(rloss,1);
   3: inc(rdraw,1);
   end;

   rat:=bp^.getsiderating(pls,n);
   if rat>rmax then rmax:=rat;
   if rat<rmin then rmin:=rat;
   srtot:=srtot+rat;

   rat1:=bp^.getsiderating(ps,n);
   if rat1>prmax then prmax:=rat1;
   if rat1<prmin then prmin:=rat1;
   prtot:=prtot+rat1;

   rat:=round((rat+rat1)/2);
   if rat>trmax then trmax:=rat;
   if rat<trmin then trmin:=rat;

   rat:=bp^.getsiderating(ops,n);
   if rat>ormax then ormax:=rat;
   if rat<ormin then ormin:=rat;
   ortot:=ortot+rat;

   rat1:=bp^.getsiderating(pops,n);
   rat:=round((rat+rat1)/2);
   if rat>otrmax then otrmax:=rat;
   if rat<otrmin then otrmin:=rat;
   otrtot:=otrtot+rat;
  end
  else begin
   inc(utot,1);
   case plres of
   1: inc(uwin,1);
   2: inc(uloss,1);
   3: inc(udraw,1);
   end;
  end;

  if bp^.isblack(pls) then
  begin
   inc(btot,1);
   case plres of
   1: inc(bwin,1);
   2: inc(bloss,1);
   3: inc(bdraw,1);
   end;
  end
  else begin
   inc(wtot,1);
   case plres of
   1: inc(wwin,1);
   2: inc(wloss,1);
   3: inc(wdraw,1);
   end;
  end;

  S:=lowercase(bp^.getareason(n));
  player:=lowercase(pl);
  opponent:=lowercase(bp^.getsideplayer(ops,n));
  pardop:=lowercase(bp^.getsideplayer(pops,n));
  partner:=lowercase(bp^.getsideplayer(ps,n));

  if pos(player+' forfeits on time',s)>0  then
  begin
   inc(floss,1);
   continue;
  end;
  if pos(partner+' forfeits on time',s)>0  then
  begin
   inc(floss,1);
   continue;
  end;
  if pos(opponent+' forfeits on time',s)>0  then
  begin
   inc(fwin,1);
   continue;
  end;
  if pos(pardop+' forfeits on time',s)>0  then
  begin
   inc(fwin,1);
   continue;
  end;

  if pos(player+' resign',s)>0  then
  begin
   inc(resloss,1);
   continue;
  end;
  if pos(partner+' resign',s)>0  then
  begin
   inc(resloss,1);
   continue;
  end;
  if pos(opponent+' resign',s)>0  then
  begin
   inc(reswin,1);
   continue;
  end;
  if pos(pardop+' resign',s)>0  then
  begin
   inc(reswin,1);
   continue;
  end;

  if pos(player+' checkmated',s)>0  then
  begin
   inc(mloss,1);
   continue;
  end;
  if pos(partner+' checkmated',s)>0  then
  begin
   inc(ploss,1);
   continue;
  end;
  if pos(opponent+' checkmated',s)>0  then
  begin
   inc(mwin,1);
   continue;
  end;
  if pos(pardop+' checkmated',s)>0  then
  begin
   inc(pwin,1);
   continue;
  end;

 end;

// if rtot>0 we show stats, else we show "-" in rated games line
 if (rtot>0) then
 begin
  str(rtot,s); label7.caption:=s;
  str(rwin,s); label8.caption:=s;
  str(rloss,s); label9.caption:=s;
  str(rdraw,s); label10.caption:=s;
  if (rwin+rloss+rdraw)>0 then
  begin
   str(round(100*(rwin+0.5*rdraw)/(rwin+rloss+rdraw)),s);
   label62.caption:=s;
  end
  else label62.caption:=NOTHING;
 end
 else begin label7.caption:=NOTHING; label8.caption:=NOTHING; label9.caption:=NOTHING; label10.caption:=NOTHING; label62.caption:=NOTHING; end;

 if (utot>0) then
 begin
  str(utot,s); label12.caption:=s;
  str(uwin,s); label13.caption:=s;
  str(uloss,s); label14.caption:=s;
  str(udraw,s); label15.caption:=s;
  if (uwin+uloss+udraw)>0 then
  begin
   str(round(100*(uwin+0.5*udraw)/(uwin+uloss+udraw)),s);
   label63.caption:=s;
  end
  else label63.caption:=NOTHING;
 end
 else begin label12.caption:=NOTHING; label13.caption:=NOTHING; label14.caption:=NOTHING; label15.caption:=NOTHING; label63.caption:=NOTHING; end;

 if ((rtot+utot)>0) then
 begin
  str(rtot+utot,s); label42.caption:=s;
  str(rwin+uwin,s); label43.caption:=s;
  str(rloss+uloss,s); label44.caption:=s;
  str(rdraw+udraw,s); label45.caption:=s;
  if (rwin+rloss+rdraw+uwin+uloss+udraw)>0 then
  begin
   str(round(100*(rwin+uwin+0.5*udraw+0.5*rdraw)/(rwin+rloss+rdraw+uwin+uloss+udraw)),s);
   label64.caption:=s;
  end
  else label64.caption:=NOTHING;
 end
 else begin label42.caption:=NOTHING; label43.caption:=NOTHING; label44.caption:=NOTHING; label45.caption:=NOTHING; label64.caption:=NOTHING; end;


 if (wtot>0) then
 begin
  str(wtot,s); label67.caption:=s;
  str(wwin,s); label68.caption:=s;
  str(wloss,s); label69.caption:=s;
  str(wdraw,s); label70.caption:=s;
  if (wwin+wloss+wdraw)>0 then
  begin
   tmp:=(wwin+0.5*wdraw)/(wwin+wloss+wdraw);
   tmp:=100*tmp;
   str(round(tmp),s);
   label71.caption:=s;
  end
  else label71.caption:=NOTHING;
 end
 else begin label67.caption:=NOTHING; label68.caption:=NOTHING; label69.caption:=NOTHING; label70.caption:=NOTHING; label71.caption:=NOTHING; end;


 if (btot>0) then
 begin
  str(btot,s); label72.caption:=s;
  str(bwin,s); label73.caption:=s;
  str(bloss,s); label74.caption:=s;
  str(bdraw,s); label75.caption:=s;
  if (bwin+bloss+bdraw)>0 then
  begin
   str(round(100*(bwin+0.5*bdraw)/(bwin+bloss+bdraw)),s);
   label76.caption:=s;
  end
  else label76.caption:=NOTHING;
 end
 else begin label72.caption:=NOTHING; label73.caption:=NOTHING; label74.caption:=NOTHING; label75.caption:=NOTHING; label76.caption:=NOTHING; end;


 if rtot>0 then begin
  str(rmax,s); label22.caption:=s;
  str(rmin,s); label23.caption:=s;
  str(round(srtot/rtot),s); label26.caption:=s;

  str(ormax,s); label30.caption:=s;
  str(ormin,s); label31.caption:=s;
  str(round(ortot/rtot),s); label32.caption:=s;

  str(prmax,s); label27.caption:=s;
  str(prmin,s); label28.caption:=s;
  str(round(prtot/rtot),s); label29.caption:=s;

  str(trmax,s); label35.caption:=s;
  str(trmin,s); label36.caption:=s;
  str(round((srtot+prtot)/(2*rtot)),s); label37.caption:=s;

  str(otrmax,s); label38.caption:=s;
  str(otrmin,s); label39.caption:=s;
  str(round(otrtot/rtot),s); label40.caption:=s;
 end
 else begin
  label22.caption:=NOTHING;
  label23.caption:=NOTHING;
  label26.caption:=NOTHING;

  label27.caption:=NOTHING;
  label28.caption:=NOTHING;
  label29.caption:=NOTHING;

  label30.caption:=NOTHING;
  label31.caption:=NOTHING;
  label32.caption:=NOTHING;

  label35.caption:=NOTHING;
  label36.caption:=NOTHING;
  label37.caption:=NOTHING;

  label38.caption:=NOTHING;
  label39.caption:=NOTHING;
  label40.caption:=NOTHING;
 end;

 restags:=bwin+wwin+bloss+wloss;
 if (restags>0) then
 begin
  str(fwin,s); label53.caption:=s;
  str(floss,s); label54.caption:=s;
  str(round(100*(fwin+floss)/restags),s);
  label81.caption:=s;
  str(mwin,s); label55.caption:=s;
  str(mloss,s); label56.caption:=s;
  str(round(100*(mwin+mloss)/restags),s);
  label82.caption:=s;
  str(pwin,s); label57.caption:=s;
  str(ploss,s); label58.caption:=s;
  str(round(100*(pwin+ploss)/restags),s);
  label83.caption:=s;
  str(reswin,s); label59.caption:=s;
  str(resloss,s); label60.caption:=s;
  str(round(100*(reswin+resloss)/restags),s);
  label84.caption:=s;
  str(wwin+bwin,s); label78.caption:=s;
  str(wloss+bloss,s); label79.caption:=s;
  str(100,s);
  label85.caption:=s;

  othertot:=restags-fwin-floss-mwin-mloss-pwin-ploss-reswin-resloss;
  if (othertot>0) then
  begin
   otherwin:=uwin+rwin-fwin-mwin-pwin-reswin;
   otherloss:=uloss+rloss-floss-mloss-ploss-resloss;
   str(otherwin,s);
   label87.Caption:=s;
   str(otherloss,s);
   label88.Caption:=s;
   str(round(100*othertot/restags),s);
   label89.Caption:=s;
  end
  else begin
   label87.Caption:=NOTHING;
   label88.Caption:=NOTHING;
   label89.Caption:=NOTHING;
  end;
 end
 else begin
  label53.caption:=NOTHING;
  label54.caption:=NOTHING;
  label81.caption:=NOTHING;

  label55.caption:=NOTHING;
  label56.caption:=NOTHING;
  label82.caption:=NOTHING;

  label57.caption:=NOTHING;
  label58.caption:=NOTHING;
  label83.caption:=NOTHING;

  label59.caption:=NOTHING;
  label60.caption:=NOTHING;
  label84.caption:=NOTHING;

  label78.caption:=NOTHING;
  label79.caption:=NOTHING;
  label85.caption:=NOTHING;

 end;
end;

procedure TStatsForm.Button2Click(Sender: TObject);
begin
 close;
end;

procedure TStatsForm.Button1Click(Sender: TObject);
begin
 edit1.text:=trim(edit1.text);
 label16.caption:=edit1.text;
 genstat(edit1.text);
end;

end.
