(*============================================================================*)
(* TYPE.INC -- Types                                                          *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* BPGNVIEW.EXE -- BPGN file viewer.                                          *)
(* Copyright (C) 1998  Zon Juan Jan                                           *)
(*                                                                            *)
(* This program is free software; you can redistribute it and/or              *)
(* modify it under the terms of the GNU General Public License                *)
(* as published by the Free Software Foundation; either version 2             *)
(* of the License, or (at your option) any later version.                     *)
(*                                                                            *)
(* This program is distributed in the hope that it will be useful,            *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of             *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *)
(* GNU General Public License for more details.                               *)
(*                                                                            *)
(* You should have received a copy of the GNU General Public License          *)
(* along with this program; if not, write to the Free Software Foundation,    *)
(* Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(* HISTORY                                                                    *)
(* -------                                                                    *)
(* 1998.11.03: First construction.                                            *)
(*                                                                            *)
(*============================================================================*)
TYPE
    FileString = ARRAY[0..(MAX_STRING - 1)] OF Char;

    BoardArray   = ARRAY[1..8, 1..8] OF Char;
    PromoteArray = ARRAY[1..8, 1..8] OF Boolean;

    MoveRecord = RECORD
        nFromX:                   Integer;
        nFromY:                   Integer;
        nToX:                     Integer;
        nToY:                     Integer;
        cPiece:                   Char;
        cPromote:                 Char;
        cCapture:                 Char;
        cType:                    Char;
        bCapturedIsPromotedPiece: Boolean;
    END;

    BPGNRecord = RECORD
        nWTime:      Integer;
        nBTime:      Integer;

        aKingBX:     ARRAY[1..2] OF Integer;
        aKingBY:     ARRAY[1..2] OF Integer;

        aKCastle:    ARRAY[1..2] OF Boolean;
        aQCastle:    ARRAY[1..2] OF Boolean;

        mPrev:       MoveRecord;

        aBoard:      BoardArray;
        aPromote:    PromoteArray;
        acPiece:     ARRAY[1..2,1..8] OF Char;
        anPiece:     ARRAY[1..2,1..8] OF Integer;
        bWhitesMove: Boolean;

        cCaption:    String;
    END;

